	PAGE	80,132
	TITLE	EPSON.SYS  VERSION V 1.4

;
;-------------------------------------------------------;
; This is a ansi driver for epson apollo pc written in	;
; microsoft assembly langusge				;
;-------------------------------------------------------;
;							;
;			History				;
;		       ----------			;
;							;		
; Date    Version    Comment				;
; ------ ---------  ----------------------------------- ;
; 10/8/84  V 1.0    Original version			;
; 10/9/84  V 1.1    del video io and char gen		;	
; 10/31/84 V 1.2    modified ibmout0 routine to initial	;
;		    page value				;	
; 11/04/84 v 1.3    modified video routine		;
; 11/08/84 V 1.4    seperate apollo and video		;
; 1/21/85  V 1.5    modified ctrl_c 			;
;-------------------------------------------------------;
;
 
int_video	equ	10h
fn_read_ansi	equ	4bh
fn_read_ansi_nodst	equ	4ch
fn_flush_ansi	equ	4fh
fn_write_ansi	equ	4ah

int_kybd	equ	16h
fn_flush_kb	equ	40h

mapr	equ	3cfh
cntr	equ	3ceh

req_seg	segment public
req_seg	ends

data	segment at 0

	org	10h*4
addr_int_video	dd	?

	org	1bh*4
int_cntrl_c	dd	?		;interrupt 1bh (control-c interrupt) 

	org	1dh*4
parm_ptr	dd	?

	org	1fh*4
ext_ptr	dd	?

	org	29h*4
addr_int_conout_fast	dd	?
	org	29h*4
int_fast_out	dd	?		;interrupt 29h (fast console output)

	org	44h*4
ext_ptr0	dd	?

	org	41ah
buffer_head	dw	?		;pointer to head of keyboad buffer
buffer_tail	dw	?		;pointer to tail of keyboad buffer

	org	410h
EQUIP_FLAG	DW	?
	org	449h
CRT_MODE	DB	?
CRT_COLS	DW	?
CRT_LEN		DW	?
CRT_START	DW	?
CURSOR_POSN	DW	8 DUP(?)
CURSOR_MODE	DW	?
ACTIVE_PAGE	DB	?	;current page being displayed
ADDR_6845	DW	?
CRT_MODE_SET	DB	?
CRT_PALETTE	DB	?

;
data	ends

code	segment	public


	assume	cs:code,ds:code



;
;	header
;
req_hdr	struc
cmdlen	db	?
unit	db	?
cmdcode	db	?
status	dw	?
reserve	db	8 dup(?)
req_hdr	ends
;
;
;	read / write
;
;
rdwr	struc
		db	13 dup(?)
;
media	db	?
trans	dd	?
sec_count	dw	?
start_sec	dw	?
rdwr	ends
;
; media check
;
mdck	struc
		db	13 dup(?)
		db	?
ret_byte	db	?
mdck	ends
;
;
; init
;
;
inits	struc
		db	13 dup(?)
;
units		db	?
break_off	dw	?
break_seg	dw	?
bpb_ptr_off	dw	?
bpb_ptr_seg	dw	?
inits	ends
;

condev	label	byte	;header	for device con
	dd	-1		;link to next device
	dw	0c013h		;attributes - console input, output device
				; special devicei, io cntrol
	dw	strategy	;srategy entry point
	dw	ibm_int		;interrupt entry point
	db	'CON     '	;device	name





	
attr_modify_tab	label	byte
	db	0			;all attribute off
	dw	0700h
	db	1			;bold on (high 
	dw	08ffh
	db	4			;underscore on
	dw	01f8h
	db	5			;blink on
	dw	80ffh
	db	7			;revers video on
	dw	70f8h
	db	8			;cancelled on (invisible)
	dw	0088h
	db	30			;black foreground
	dw	00f8h
	db	31			;red foreground
	dw	04f8h
	db	32			;green foreground
	dw	02f8h
	db	33			;yellow foreground
	dw	06f8h
	db	34			;blue foreground
	dw	01f8h
	db	35			;magenta foreground
	dw	05f8h
	db	36			;cyan foreground
	dw	03f8h
	db	37			;white foreground
	dw	07f8h
	db	40			;black background
	dw	008fh
	db	41			;red background
	dw	408fh
	db	42			;green background
	dw	208fh
	db	43			;yellow background
	dw	608fh
	db	44			;blue background
	dw	108fh
	db	45			;magenta background
	dw	508fh
	db	46			;cyan background
	dw	308fh
	db	47			;white background
	dw	708fh
	db	0ffh
;
cmdtabl	db	'f'			;horizontal and vertical position
	dw	hvp			;	esc+"["+x+y+"f" (same as 'cup')
	db	'h'			;set mode
	dw	sm			;	esc+"[="+x+"h" etc.
	db	'l'			;reset mode
	dw	rm			;	esc+"[?7h" etc.
	db	'm'			;special video mode
	dw	sgr			;	esc+"["+x1+x2+..+xn+"m"
	db	'n'			;device status report
	dw	dsr			;	esc+"[6n"
	db	'p'			;keyboad key reassignment
	dw	rak			;	esc+"["+x1+x2+..+xn+"p"
	db	's'			;save cursor position. esc+"[s"
	dw	scp			;	esc+"[s"
	db	'u'			;restore cursor position
	dw	rcp			;	esc+"[u"
	db	'A'			;cursor up y rows
	dw	cuu			;	esc+"["+y+"A"
	db	'B'			;cursor down y rows
	dw	cud			;	esc+"["+y+"B"
	db	'C'			;cursor forward x columns
	dw	cuf			;	esc+"["+x+"C"
	db	'D'			;cursor back x columns
	dw	cub			;	esc+"["+x+"D"
	db	'H'			;direct cursor position at (x,y)
	dw	cup			;	esc+"["+y+x+"H"
	db	'J'			;erase in display
	dw	ed			;	esc+"[2J"
	db	'K'			;erase in line
	dw	el			;	esc+"[K"
	db	'R'			;cursor position report
	dw	cpr			;	esc+"["+x+y+"R"
	db	0ffh			;end of table

ptrsav	dd	?			;strategy poiter save

;
; simplistic strategy routine for non-multi-tasking system
;
;	currently just saves i/o packet poiters in prnsav for
;	later processing bu the indivisual interrupt routines.
;

stratp	proc	far

strategy:
	mov	cs:word ptr ptrsav,bx
	mov	cs:word ptr ptrsav+2,es
	ret

stratp	endp	

ibm_tbl	label	word
	dw	ibm_init	;0  - init. (not used)
	dw	exit		;1  - media check (not used)
	dw	exit		;2  - get bios parameter block (not used)
	dw	cmderr		;3  - reserved.	(currently returns error)
	dw	ibm_read	;4  - character	read. (destructive)
	dw	ibm_rdnd	;5  - character	read. (non-destructive)
	dw	exit		;6  - return status. (not used)
	dw	ibm_flsh	;7  - flush input buffer.
	dw	ibm_writ	;8  - character	write.
	dw	ibm_writ	;9  - character	write with verify.
	dw	exit		;10 - character	write status.
	dw	exit		;11 - flush output buffer. (not	used.)

assume	cs:code,ds:nothing,es:nothing,ss:nothing

;
; common program for handling the simplistic i/o packet
;   processing scheme in msdos 2.0
;
ibm_int:
	push	si
	mov	si,offset ibm_tbl
interrupt:
	push	ax			;save all nessacary registers.
	push	bx
	push	cx
	push	dx
	push	di
	push	ds
	push	es

	lds	bx,ptrsav		;retrieve pointer to i/o packet.
assume	ds:req_seg

	mov	al,req_seg:[bx].cmdcode
	cmp	al,11
	ja	cmderr_1
dev_int_1:
	cbw
	shl	ax,1
	add	si,ax
	mov	al,req_seg:[bx].unit	;al = unit code.
	mov	ah,req_seg:[bx].media	;ah = media descriptor.
	mov	cx,req_seg:[bx].sec_count	;cx = contains byte/sector count.
	les	di,req_seg:[bx].trans	;di contains addess of transfer	address.
assume	es:nothing			;es contains segment.

	mov	bx,cs
	mov	ds,bx			;ds point to data segment.
assume	ds:code
	jmp	word ptr [si]		;perform i/o packet command.

assume	cs:code,ds:code,es:nothing,ss:nothing
exitp	proc	far		;normal	exit for device	drivers.


exit:
	mov	ah,00000001b	;set done bit for msdos.
exit1:
	lds	bx,ptrsav
assume	ds:req_seg
exit2:
	mov	req_seg:[bx].status,ax	;save operation	compete	and status.

	pop	es			;restore registers
	pop	ds
	pop	di
	pop	dx
	pop	cx
	pop	bx		
	pop	ax
	pop	si
	ret				;restore regs and return


assume	cs:code,ds:code,es:nothing,ss:nothing

bsy_exit:			;device	busy exit.
	mov	ah,00000011b	;set busy and done bits.
	jmp	short exit1

cmderr_1:
cmderr:
	mov	al,3		;set unknown command error #.

;
;  common error	processing routine.
;   al contains	actual error code.
;
;   error # 0 =	write protect violation.
;	    1 =	unkown unit.
;	    2 =	drive not ready.
;	    3 =	unknown	command	in i/o packet.
;	    4 =	crc error.
;	    5 =	bad drive request structure length.
;	    6 =	seek error.
;	    7 =	unknown	media discovered.
;	    8 =	sector not found.
;	    9 =	printer	out of paper.
;	   10 =	write fault.
;	   11 =	read fault.
;	   12 =	general	failure.
;

err_exit:
	mov	ah,10000001b	;set error and done bits.
	jmp	short exit1
err_exit_n:
	mov	ah,10000001b
err_exit_n1:
	lds	bx,ptrsav
assume	ds:req_seg
	sub	req_seg:[bx].sec_count,cx
	jmp	exit2


exitp	endp

eps_video	dd	?
ibm_video	dd	?

cntr_mode	db	?


ctrl_c:	mov	byte ptr cs:char,3	;cotrol-c interrupt
;	jmp	dword ptr cs:cntrl_c_next
	
; v 1.5 
	iret
; v 1.5
	

set_mode_data	db	0
str_buf_offset	dw	4
state		dw	offset st1
scrn_mode	db	3
max_column	db	4fh
curs_column	db	0
curs_row	db	0
save_curs_data	dw	0
temp		db	0
esc_para_ptr	db	0
		db	0
curs_buf_cont	db	0
curs_buf_addr	dw	offset str_buf
curs_buf	db	1bh			;escape
		db	5bh			;'['
		db	30h,30h			;cursor row position (ascii)
		db	3bh			;';'
		db	30h,30h			;cursor column position (ascii)
		db	52h			;'R'
		db	0dh			;cr
char		db	0
attr		db	7
scrn_page	db	0
crt_buf_addr	dw	0b800h
crt_page_addr	dw	0

cntrl_c_next	dd	?




;
; ibmsole non-destructive read
;

ibm_rdnd:
	mov	al,char
	or	al,al
	jnz	crdnd3
	cmp	curs_buf_cont,0
	jz	crdnd1
	mov	bx,curs_buf_addr
	mov	al,[bx]
	jmp	short crdnd3

crdnd1:	mov	ah,1
	int	16h
	jz	crdnd5
	or	ax,ax
	jnz	crdnd2
	mov	ah,0
	int	16h
	jmp	ibm_rdnd

crdnd2:	call	chk_str_buf
	jnz	crdnd3
	mov	al,[bx+2]
	cmp	byte ptr [bx+1],0
	jnz	crdnd3
	mov	al,[bx+3]
crdnd3:	lds	bx,ptrsav
	mov	[bx+0dh],al
crdnd4:	jmp	exit

crdnd5:	jmp	bsy_exit

;
; ibmsole destructive read
;

ibm_read:
	jcxz	cr2
cr1:	push	cx
	call	cinp			;get character
	pop	cx
	stosb
	loop	cr1			;loop untill cx is exhausted
cr2:	jmp	exit

;
; get a character from the buffer queue
;

cinp:	
	sub	ax,ax
	xchg	char,al
	or	al,al			;check char
	jnz	cinp1			;if there is any,return
cinp4:	
	mov	cl,curs_buf_cont
	or	cl,cl			;is there any characters in curs_buf
	jnz	chk_curs_buf		;yes,there is
	xor	ah,ah			;get character from keyboad
	int	16h
	call	chk_str_buf		;check buffer including string blocks
	jnz	cinp2
	sub	cx,2
	add	bx,2
	or	al,al
	jnz	cinp3
	dec	cx
	inc	bx
cinp3:	
	mov	curs_buf_addr,bx
	call	chk_curs_buf
cinp2:	or	ax,ax
	jz	cinp4
	or	al,al
	jnz	cinp1
	mov	char,ah
cinp1:	ret

chk_curs_buf:
	dec	cl
	mov	bx,curs_buf_addr
	mov	ax,[bx]			;get top 2 characters of curs_buf
	inc	bx
	or	al,al
	jnz	ccb1
	inc	bx
	dec	cl
ccb1:	
	mov	curs_buf_cont,cl
	mov	curs_buf_addr,bx	;set new pointer
	ret
;
; console flush routine (ctrl-c,ctrl-f,ctrl-s inspired)
;

ibm_flsh:
	mov	char,0
	mov	curs_buf_cont,0
	push	ds
	xor	ax,ax
	mov	ds,ax
	assume	ds:data			;initialize keyboad buffer
	mov	byte ptr buffer_head,1eh ;buffer head
	mov	byte ptr buffer_tail,1eh ;buffer tail
	assume	ds:code
	pop	ds

	jmp	exit
;
;
chk_str_buf:
	mov	bx,offset str_buf	;bx = string buffer pointer
csb1:	mov	cl,[bx]	
	xor	ch,ch			;cx = string block size
	or	cx,cx			;end block ?
	jz	csb4			;yes, end block
	or	al,al			;null character ?	
	jnz	csb2			;no
	cmp	ax,[bx+1]		
	jmp	short csb3

csb2:	cmp	al,[bx+1]		;fit the char with one of the buffer ?
csb3:	jz	csb5			;yes, fitted 
	add	bx,cx			;no, search next string block
	jmp	csb1

csb4:	or	bx,bx
csb5:	ret
;
yes_cr:
	mov	curs_column,0
	jmp	short set_curs_pos
;
write_tty1:
	mov	bx,word ptr attr;set attribute and screen page
	and	bl,7		;character attribute
	mov	ah,0eh		;write tty
	int	int_video
wt_ret:	ret
;
back_space:
	cmp	curs_column,0	;if not left edge of screen, move cursor left
	jz	wt_ret
	dec	curs_column
	jmp	short set_curs_pos
;
outchr:	
	cmp	al,0dh		;carriage return ?
	jz	yes_cr		;yes
	cmp	al,0ah		;line feed ?
	jz	yes_lf		;yes
	cmp	al,7		;bell ?
	jz	write_tty1	;yes
	cmp	al,8		;back space ?
	jz	back_space	;yes

write_chr_attr:
	mov	bx,word ptr attr	;get page and attribute
	mov	cx,1			;1 character
	mov	ah,9			;write chr/attr on screen
	int	int_video
	inc	curs_column		;increment cursor column position,
	mov	al,curs_column		;and if not right edge of screen, jump
	cmp	al,max_column		;set cursor position
	jbe	set_curs_pos
	cmp	set_mode_data,0
	jz	lf0
	dec	curs_column
	ret

lf0:	mov	curs_column,0
yes_lf:	inc	curs_row
	cmp	curs_row,19h		;if bottom line of screen,scroll 1 line up
	jb	set_curs_pos
	mov	curs_row,18h
	call	scroll_up_1		;scroll 1 line up
set_curs_pos:
	mov	dx,word ptr curs_column		
	mov	bh,scrn_page		;screen page	
	mov	ah,2			;set cursor position
	int 	int_video
	ret

scroll_up_1:
	mov	al,scrn_mode
	cmp	al,2
	jz	mode2_3
	cmp	al,3
	jz	mode2_3
	mov	al,0ah
	jmp	write_tty1

mode2_3:mov	bh,attr
	mov	bl,20h
	mov	bp,50h
	mov	ax,crt_buf_addr
	add	ax,crt_page_addr
	mov	es,ax			;set segment resister
	mov	ds,ax
	xor	di,di
	mov	si,00a0h
	mov	cx,0780h
	cld
	cmp	word ptr cs:crt_buf_addr,0b800h
	jz	scrl2
repz	movsw
	mov	ax,bx
	mov	cx,bp
repz	stosw
scrl1:	push	cs
	pop	ds
	ret

scrl2:	mov	dx,3dah
scrl3:	in	al,dx
	test	al,8
	jz	scrl3	
	mov	al,25h
	mov	dx,3d8h
	out	dx,al
repz	movsw
	mov	ax,bx
	mov	cx,bp
repz	stosw
	mov	al,29h
	mov	dx,03d8h
	out	dx,al
	jmp	scrl1

ibmout_fast:				;interrupt fast console out
	sti
	push	ds
	push	cs
	pop	ds			;ds = cs segment resister
	call	ibmout0
	pop	ds
	iret
;
; console output routine
;

ibm_writ:
	jcxz	cw2
cw1:	mov	al,es:[di]
	inc	di
	call	ibmout0
	loop	cw1
cw2:
	jmp	exit


ibmout0:
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	es
	push	bp
	mov	word ptr crt_buf_addr,0b800h ;set color crt buffer address
	xchg	si,ax
	xor	ax,ax
assume	ds:data
	mov	ds,ax			;set absolute data segment
	mov	ax,word ptr crt_mode	;get crt_mode and number of columns
	dec	ah
	mov	word ptr cs:scrn_mode,ax  
	cmp	al,7
	jnz	cout1
	mov	word ptr cs:crt_buf_addr,0b000h
cout1:	
	mov	al,active_page
	mov	cs:scrn_page,al
	cbw
	add	ax,ax
	mov	bx,ax
	mov	ax,cursor_posn[bx]
	mov	word ptr cs:curs_column,ax
	mov	ax,crt_start		;get starting address in regen buffer
	mov	cl,4
	shr	ax,cl			;ax = ax / 16
	push	cs
assume	ds:code
	pop	ds			;ds = cs segment resister (get back)
	mov	crt_page_addr,ax
	xchg	si,ax
	mov	si,offset state
	call	word ptr [si]
	pop	bp
	pop	es
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret


;
; state one
;	look for an escape character
;

st1:	cmp	al,1bh			;see if this the first character is esc
	jnz	st11
	mov	word ptr [si],offset st2
	ret

st11:	call	outchr
st12:	mov	word ptr state,offset st1
	ret
		
;
; state twe
;	looks for the "[" character
;

st2:	cmp	al,'['			;see if a valide state two
	jz	st21
	jmp	st1

st21:	mov	word ptr [si],offset st3
	xor	bx,bx
	mov	word ptr temp,bx	;clear temp and esc para pointer
st22:
	call 	get_pointer		;get buffer pointer
	mov	word ptr [bx],0			;set to zero
	ret
 
;
; state three
;	entrerd one or more times for parameter passing
;

st3:	cmp	al,';'			;look for decimal # separater
	jnz	st3a			;no, check phase a
st31:	inc	esc_para_ptr
	jmp	short st22

;
; state three a
;	check for a ascii digit
;

st3a:	
	cmp	al,'9'			;still checking for ascii digit
	ja	st3b			;no, it must be a secondery
	cmp	al,'0'			;check for a ascii digit
	jb	st3b			;no, check for secondery command character
	sub	al,30h			;convert to binary
	call	get_pointer
	xchg	[bx],al			;get existing #
	mov	ah,0ah			;scale by 10
	mul	ah
	add	[bx],al			;add to new digit
	ret

;
; state three b
;	wasn't a ascii digit, so check for secondery command
;

st3b:	
	cmp	al,'"'
	jz	st3b2
	cmp	al,'?'
	jz	st3b1
	cmp	al,'='
	jz	st3b1
	cmp	al,27h
	jnz	select_command
st3b2:	mov	word ptr [si],offset st4
	mov	temp,al
st3b1:	ret

;
; state foure
;

st4:	cmp	al,temp
	jnz	st41
	dec	esc_para_ptr
	mov	word ptr [si],offset st3
	ret

st41:	call	get_pointer
	mov	[bx],al
	mov	word ptr [si],offset st4
	jmp	st31

select_command:				;select command vector from table
	mov	bx,offset cmdtabl-3
sc1:	add	bx,3
	cmp	byte ptr [bx],0ffh
	jz	sc3
	cmp	[bx],al
	jnz	sc1
	mov	ax,[bx+1]
	mov	bx,offset str_buf
	add	bx,str_buf_offset
	inc	bx
	mov	cl,[bx]
	xor	ch,ch
	mov	dx,cx
	or	dx,dx
	jnz	sc2
	inc	cx
sc2:	jmp	ax
sc3:
	jmp	st11

get_pointer:
	mov	bx,str_buf_offset
	add	bx,word ptr esc_para_ptr
	inc	bx
	cmp	bx,200
	jb	gap1
	dec	esc_para_ptr
	jmp	get_pointer

gap1:	add	bx,offset str_buf
	ret
;
; change cursor data for each command and set cursor position
;

chg_curs_data:
	cmp	[bx],dh
	jz	set_curs_pos2
	add	[bx],dl
	loop	chg_curs_data
set_curs_pos2:
	mov	dx,word ptr curs_column
	xor	bx,bx
	mov	ah,2
	int	int_video
	jmp	st12

;
; set cursor position directry
;

cup:
hvp:	
	mov	ch,cl
	cmp	ch,19h			;above max row of screen ?
	ja	set_curs_pos2		;yes, not change cursor data
	mov	al,max_column
	mov	cl,[bx+1]		;get column value
	or	cl,cl
	jz	cup1
	dec	cl
cup1:	cmp	cl,al			;under or equel max column # ?
	jbe	cup2			;yes
	mov	cl,al			;no, set max column value
cup2:					;ch=row, cl=column
	dec	ch
	mov	word ptr curs_column,cx	;set new cursor position
	jmp	set_curs_pos2

;
; move cursor down n rows
;

cud:	mov	dx,1801h
cud1:	mov	bx,offset curs_row
	jmp	chg_curs_data

;
; move cursor up n rows
;

cuu:	mov	dx,0ffh
	jmp	cud1

;
; move cursor forward n columns
;

cuf:
	mov	dl,1			;for increment column position
	mov	dh,max_column
	jmp	cub1

;
; move cursor backward n columns
;

cub:	mov	dx,0ffh			;for decrement column position
cub1:	mov	bx,offset curs_column
	jmp	chg_curs_data

;
; save cursor position
;

scp:	mov	dx,word ptr curs_column
	mov	save_curs_data,dx
	jmp	set_curs_pos2
	
;
; restore cursor position
;

rcp:	mov	dx,save_curs_data
	mov	word ptr curs_column,dx
	jmp	set_curs_pos2

;
; set graphics rendition
;

sgr:	xor	cx,cx
	xchg	esc_para_ptr,cl
	call	get_pointer
	inc	cx
sgr3:	mov	al,[bx]
	push	bx
	mov	bx,offset attr_modify_tab
sgr2:	mov	ah,[bx]
	add	bx,3
	cmp	ah,0ffh
	jz	sgr1
	cmp	ah,al
	jnz	sgr2
	mov	ax,[bx-2]
	and	attr,al
	or	attr,ah
sgr1:	pop	bx
	inc	bx
	loop	sgr3
	jmp	set_curs_pos2

;
; erase in display
;

ed:	
	mov	dh,19h
	xor	cx,cx
	mov	word ptr curs_column,cx
	jmp	scroll_page_up

;
; erase in line
;

el:	
	mov	cx,word ptr curs_column
	mov	dh,ch
scroll_page_up:
	mov	dl,max_column
	mov	bh,attr
	mov	ax,600h
	int	int_video
	jmp	set_curs_pos2
		

;
; device status report
;

dsr:	
	mov	curs_buf_cont,9
	mov	al,curs_column
	call	chg_bin_asc
	mov	word ptr curs_buf+5,ax
	mov	al,curs_row
	call	chg_bin_asc
	mov	word ptr curs_buf+2,ax
	mov	curs_buf_addr,offset curs_buf

;
; cursor position report
;

cpr:	jmp	st12

;
; change binary to ascii
chg_bin_asc:
	mov	dl,0ah
	inc	al
	xor	ah,ah
	div	dl
	add	ax,3030h
	ret

;
; reset mode
;

rm:	mov	cl,1
	jmp	short sm1
	
;
; set mode
;
sm:	xor	cx,cx
sm1:	mov	al,dl
	cmp	al,7
	ja	sm3
	jb	sm2
	mov	set_mode_data,cl
	ret

sm2:	mov	ah,0
	int	int_video
sm3:
	jmp	st12

;
; keyboad key reassignment
;

rak:	xor	dx,dx
	xchg	esc_para_ptr,dl
	call	get_pointer
	mov	ax,[bx]
	call	chk_str_buf
	jnz	rak1
	mov	di,bx
	mov	si,bx
	add	si,cx
	sub	str_buf_offset,cx
	mov	cx,offset str1
	sub	cx,si
	push	es
	push	cs
	pop	es
	cld
repz	movsb
	pop	es
rak1:	call	get_pointer
	or	dl,dl
	jz	rak2
	inc	dx
	inc	dx
	mov	[bx-1],dl
	add	str_buf_offset,dx
	add	bx,dx
rak2:	mov	byte ptr [bx-1],0
	mov	word ptr state,offset st1
	ret


str_buf	label	byte
	db	4,0,72h,10h
	db	196 dup (0)
str1	db	0

;
	

assume	cs:code,ds:code,es:nothing,ss:nothing


ibm_init:
	
; set default mode

	xor	bx,bx
	mov	ds,bx
assume	ds:data
; set up control c vector
	mov	word ptr int_cntrl_c,offset ctrl_c
	mov	word ptr int_cntrl_c+2,cs

	
	mov	word ptr addr_int_conout_fast,offset ibmout_fast
	mov	word ptr addr_int_conout_fast+2,cs
	
;
	mov	al,crt_mode
	push	cs
	pop	ds

assume	ds:code
	
	mov	scrn_mode,al
	
	mov	word ptr crt_buf_addr,0b800h
	cmp	al,7
	jnz	mode_sub_1
	mov	word ptr crt_buf_addr,0b000h
mode_sub_1:

	mov	byte ptr max_column,4fh
	cmp	al,01
	ja	mode_sub_2
	mov	byte ptr max_column,27h
mode_sub_2:
	
	lds	bx,cs:ptrsav
assume	ds:code
	mov	word ptr [bx+0eh],offset ibm_init
	mov	[bx+10h],cs
	jmp	exit

code	ends

	end
