PAGE 60,132

        TITLE   DISKCOPY MSDOS Disk Copier
;----------------------------------------------------------
;
;       Diskcopy - Program to copy entire diskettes
;
;       Copyright 1982 by Microsoft Corporation
;       Written by Chris Peters, August 1982
;
;-----------------------------------------------------------
;
; Rev 1.00      Initial instance
; Rev 1.20
;               Read in > 64K hunks
; 01/02/85 HAPPY NEW YEAR - allows disk formatting. Vuong Tran
;
; 01/04/85 - Forbids copying from/to hard disk
;
; 01/10/85 - If target disk has defects <diskcopy> will inform user
;
; 01/22/85 - report error messages if /1 or /x is selected (x is any
;	     alpha-numeric character besides 1)
; 01/23/85 - turn verify switch on/off
;


FALSE   EQU     0
TRUE    EQU     NOT FALSE
ON	EQU	1
OFF	EQU	0


bdos    equ     21h
boot    equ     20h
aread   equ     25h
awrite  equ     26h

        INCLUDE DOSSYM.ASM

fcb     equ     5ch

CODE    SEGMENT PUBLIC
	EXTRN	BOOT_SECTOR:BYTE	;BUFFER FOR BOOT SECTOR
CODE    ENDS

CONST   SEGMENT PUBLIC BYTE
	public	dest		;VQT
CONST   ENDS

DATA    SEGMENT PUBLIC BYTE
DATA    ENDS

DG      GROUP   CODE,CONST,DATA

CODE  segment PUBLIC
        assume  cs:DG,ds:DG,es:DG,ss:DG

        EXTRN   dskrd:NEAR,dskwrt:NEAR,promptyn:NEAR
	EXTRN	DISKINFO:NEAR, RD_SEC:NEAR, FORMAT_DISK:NEAR  ;VQT
;	EXTRN	FIX_FDPB:NEAR 			      ;VQT
        PUBLIC  PRINT,PCRLF,ASKANOTHER,sec64k,secsiz
	PUBLIC	UNUSABLE_DISK


        org     100h

diskcopy:
        jmp     disk_entry

HEADER  DB      "Epson MS-DOS Floppy Disk Copier",13,10,"$"
invalid_parm	db	13,10,'Invalid parameters',13,10,'$'
invalid_copy	db	13,10,'Single-sided copying is not supported',13,10,'$'

source  db      0
dest    db      0
count   dw      0
start   dw      0
secsiz  dw      0
passcnt dw      0
sec64k  dw      0
media   db      0
buffer  dw      0
bufsiz  dw      0
UNUSABLE_DISK	DB	?	;Flag set if target disk has defects

VERIFY	MACRO SWITCH
	MOV	AL, SWITCH
	MOV	AH, 2EH
	INT	21H
	ENDM


pcrlf:  mov     dx,OFFSET DG: crlf
print:  mov     ah,STD_CON_STRING_OUTPUT
        int     bdos
pret:   ret

getkey: mov     dx,OFFSET DG: keymsg
        call    print
        mov     ah,12                   ;wait for key press
        mov     al,1
        int     21h
        ret
;
; returns number of sectors on the disk in cx, sector size in ax
;
getdpb:
 	push    ds
        inc     dl
        mov     ah,GET_DPB
        int     bdos
        mov     al,[bx+dpb_cluster_mask]
        cbw
        inc     ax                      ;AX = number of sectors/cluster
        mov     cx,[bx+dpb_max_cluster] ;# of clusters on disk
        dec     cx 		;
        mul     cx
        add     ax,[bx+dpb_first_sector];total # of sectors on disk
        mov     cx,[bx+dpb_sector_size] ;size of sectors in bytes
        mov     bl,[bx+dpb_media]       ;fatid (or media byte)
        pop     ds
        ret

getdrv: mov     al,[bx]
        dec     al
        cmp     al,-1
        jnz     get1
        mov     ah,19h
        int     21h
get1:   ret
;
; set zero flag if drives the same
;
compare:push    ax
        mov     al,[dest]
        cmp     al,[source]
        pop     ax
        ret

printerr:
        call    print
        int     boot

get_switches	proc	near
;	ACTION: Get switches from unformatted parameter area.
;
		mov	ah, 37h		;read switch char
		mov	al, 0		;
		int	bdos		;which returns in (dl)
		mov	bx, 80h			;set string length in bytes
		mov	cl, byte ptr [bx]       ;
		sub	ch, ch                  ;
		mov	al, dl
		mov	di, 81h			;set string begin
		repnz	scasb
		jcxz	end_of_string
		mov	dx, offset dg:invalid_copy
		cmp	byte ptr [di], '1'
		jz	bad_option
		mov	dx, offset dg:invalid_parm
bad_option:	call	printerr
end_of_string:	ret
get_switches	endp


;-------BEGIN MAIN PROGRAM

disk_entry:
        cli                     ;set up local stack
        mov     sp,100h
        sti


;Code to print header
       PUSH    AX
       MOV     DX,OFFSET DG: HEADER
       CALL    print
       call    get_switches		;vqt
       POP     AX

        mov     dx,OFFSET DG: drverr1
        inc     al
        jz      printerr
        inc     ah
        jz      printerr

        mov     bx,fcb			;bx --> source drive (1=A, 2=B,...)
        call    getdrv
        mov     [source],al
        add     [srclet],al
        mov     bx,fcb+16 		;bx --> destination drive (1=A, 2=B,...)
        call    getdrv
        mov     [dest],al
        add     [dstlet],al
        add     [fdstlet],al
        mov     ah,DISK_RESET
        int     bdos                    ;empty buffer queue

        mov     bx,OFFSET DG:progsiz + 15 ;BX = size of program <DISKCOPY> + 15
        shr     bx,1                      ;convert it to paragraphs
        shr     bx,1                      ;
        shr     bx,1                      ;
        shr     bx,1                      ;

        mov     ah,setblock
        int     21h                     ;give back extra memory

        mov     bx,0FFFFh               ;ask for Biggest hunk
        mov     ah,alloc
        int     21h
        jnc     gotmem
        mov     ah,alloc
        int     21h
gotmem:
        mov     [buffer],ax     	;absolute address of buffer
        mov     [bufsiz],bx             ;maximum size of buffer in paragraphs

copyagn:
	MOV	BYTE PTR [UNUSABLE_DISK], 0	;Target disk has no defects on initialization
        mov     [start],0               ;Initialize start sector
        call    compare
        jz      onedrv1

;-------Changes put in by VQT
        mov     dx,OFFSET DG: srcmsg
        call    print
        mov     dx,OFFSET DG: fdstmsg
        call    print
	jmp	short wait_kbd

onedrv1:mov     dx,OFFSET DG: srcmsg
        call    print
wait_kbd:
        call    getkey              	;wait for keyboard input
        mov     dl,[source]
        call    getdpb
        mov     [count],ax
        mov     [secsiz],cx
        mov     [media],bl
	call	diskinfo		;get information about source disk
	mov	dx, OFFSET DG:MEDIA_INVALID
	JNC	COMPARE_DISK
	JMP	PRINTERR

COMPARE_DISK:
        call    compare
        jnz     twodrv1
        mov     dx,OFFSET DG: fdstmsg
        call    print
        call    getkey
twodrv1:
	;read target disk
	;if (disk not formatted) then format it
	PUSH	CS
	POP	ES
	LEA	BX, BOOT_SECTOR ;
	MOV	DL, [DEST]	;target drive
	MOV	DH, 0		;side 0
	MOV	CH, 0 		;track 0
	MOV	CL, 1		;sector #1
	MOV	AL, 01		;1 sector only
	CALL	RD_SEC		;read boot sector into memory
	JNC	TARGET_FORMATTED;go if target disk has been already formatted
	MOV	DX, OFFSET DG:DO_FORMAT_MSG
	CALL	PRINT
FORMAT_IT:
	CALL	FORMAT_DISK     ;format target disk
				;If target disk is a hard disk it will
				;be prompted for a retry and the user can
				;exit to DOS by answering no

TARGET_FORMATTED:
	mov     dl,[dest]
        call    getdpb
        mov     dx,OFFSET DG: drverr3
        cmp     [media],bl              ;make sure media and sizes match
        jnz     errv
        cmp     [count],ax
        jz      sizeok
errv:   CALL	PROMPTYN		;reformat target disk?
	CALL	PCRLF			;skip next line
	JZ	FORMAT_IT               ;yes - do it
	JMP	ALLDONE                 ;no - quit
;-------------------------------------------

sizeok:
        mov     bx,[secsiz]
        add     bx,15
        mov     cl,4
        shr     bx,cl
        xor     dx,dx
        mov     ax,1000H
        div     bx
        mov     [sec64k],ax     ;set number of sectors in 64K bytes
        xor     dx,dx
        mov     ax,[bufsiz]
        div     bx
        mov     [passcnt],ax    ;set number of sectors per pass

        call    compare
        JNZ     TWO_DRIVES
	MOV	DX, OFFSET DG:SRCMSG
	CALL	PRINT
	CALL	GETKEY
;	JMP	SHORT LOOP		;vqt
TWO_DRIVES:
        mov     dx,OFFSET DG: cpymsg	;PRINT COPYING...
        call    print

	VERIFY ON

loop:   push    ds

        mov     al,[source]
        xor     bx,bx
        mov     cx,[passcnt]
        cmp     cx,[count]
        jbe     countok
        mov     cx,[count]
countok:mov     dx,[start]
        mov     ds,[buffer]
        call    dskrd
        pop     ds

        push    ds
        push    cx

        call    compare
        jnz     twodrv2
        mov     dx,OFFSET DG: dstmsg
        call    print
        call    getkey

twodrv2:mov     al,[dest]
        xor     bx,bx
        mov     dx,[start]
        mov     ds,[buffer]
        call    dskwrt
        pop     cx
        pop     ds

        add     [start],cx
        sub     [count],cx
        jbe     quitcopy

        call    compare
        jnz     loop
        mov     dx,OFFSET DG: srcmsg
        call    print
        call    getkey
        jmp     loop

quitcopy:
        mov     ah,DISK_RESET
        int     bdos                    ;empty buffer queue
        mov     dx,OFFSET DG: goodmsg
        call    compare
        jnz     twodrv3
        mov     dx,OFFSET DG: good1

ASKANOTHER:
twodrv3:call    print
        mov     dx,OFFSET DG:anoprompt
        call    promptyn
        jnz     alldone
        jmp     copyagn
alldone:
;-----------------------------------------
	MOV	DX, OFFSET DG:DISK_UNUSABLE_MSG
	cmp	byte ptr [UNUSABLE_DISK], 0
	JZ	HOME
	CALL	PRINT
;------------------------------------------
home:	VERIFY OFF
   	int     boot            ;home, james...

CODE    ENDS

CONST   SEGMENT PUBLIC BYTE

        EXTRN   fdstmsg:BYTE,dstmsg:BYTE,fdstlet:BYTE,dstlet:BYTE
        EXTRN   cpymsg:BYTE,good1:BYTE,goodmsg:BYTE,srcmsg:BYTE,srclet:BYTE
        EXTRN   keymsg:BYTE,drverr1:BYTE,drverr3:BYTE,crlf:BYTE
        EXTRN   anoprompt:BYTE
	EXTRN	MEDIA_INVALID:BYTE, DO_FORMAT_MSG:BYTE	;VQT
	EXTRN	DISK_UNUSABLE_MSG:BYTE

        db      ' MICROSOFT - PETERS '
CONST   ENDS

DATA    SEGMENT BYTE

progsiz LABEL   BYTE

DATA    ends
        end     diskcopy
