	PAGE 63,132

	TITLE DEVICE DRIVER
	SUBTTL DATA STRUCTURES AND DEFINITION

;------------------------------------------------------------------------:
;  									 :
;  			     EPSON MSDOS BIOS  				 :
;  			FOR QX-88 AND APOLLO COMPUTERS                   :
;
;	2/25/85	NF	Make all patches to ROM dependent on old ROM byte.
;			Patches to int 8, 19, 71 installed only if old ROM.
;
;	1/25/85 NF	Fixed bug introduced by int 8 patch.
;			BUG:  Int 19 normally causes re-boot but does not
;			reinitialize hardware or int vector table.
;			As a result, timer interrupt comes in after
;			Epsonbio loaded, but before self-modifying code
;			gets executed.  Hence it sends control to int 0,
;			and system hangs.
;			FIX:  Change int 19 to point to re-start address
;			f000:fff0.  This will reinitialize all things.
;
;	1/24/85 NF	Patched timer#1 interrupt to also invoke int 8.
;			All patches can be found by searching for NF.
;  	                                                                 :
;	1/21/85	NF 	Patched real time clock driver to go direct to
;			hardware, bypassing ROM BIOS during write request.
;
;		1.  This allows us to set seconds field of time.
;
;		2.  And makes us incompatible with VENUS.
;
;		3.  THIS PATCH CAN BE REMOVED IF ROM BIOS WRITE REQUEST
;		IS MODIFIED!
;
;		4.  *****  WARNING:  THIS CODE WILL NOT WORK IF
;		IT IS INVOKED DURING AN INTERRUPTION OF THE NORMAL ROM
;		BIOS CALENDER CLOCK READ OR WRITE (INT 1A FCTS 2 OR 3).
;		OR VICE-VERSA.
;
;  	1/12/85: rtc clock driver added                                  :
;  	                                                                 :
;  	1/12/85: patch hard disk bios added, will be included at runtime :
;  	         conditionally based upon the ID byte located at:        :
;  	         f000:fffe, = FF yes else no                             :
;------------------------------------------------------------------------:
;
; 	Parameters required to communicate with MS SYSINIT module
;
FALSE	EQU	0
TRUE	EQU	NOT FALSE
RTC	EQU	TRUE			;RTC IS AVAILABLE (QX-16 ADDR)

EXTRN	SYSINIT:FAR			;Entry point of SYSINIT

EXTRN	CURRENT_DOS_LOCATION:WORD	;Original location of MSDOS.SYS
EXTRN	FINAL_DOS_LOCATION:WORD		;Relocation address for MSDOS.SYS

EXTRN	DEVICE_LIST:DWORD		;Pointer to Device table

EXTRN	MEMORY_SIZE:WORD		;RAM size in paragraphs

EXTRN	DEFAULT_DRIVE:BYTE		;Default drive to use on boot

EXTRN	BUFFERS:BYTE			;Number of buffers (DOS parameters)

EXTRN	FILES:BYTE			;Default # of files from the system


		PAGE
		
;******************************************************************************
;				EQUATES
;******************************************************************************

	INCLUDE	HARDHEAD.ASM

STACK_BASE	EQU	700H				;Stack base at base of BIOS

EOI		EQU	20H				;End of interrupt command to controller
INTA0		EQU	08H				;Interrupt controller port 0

	;ROM ROUTINE EQUATES

		;INTERRUPTS
EQUIP_INT	EQU	11H				;Equipment check interrupt
MEM_SIZE_INT	EQU	12H				;Memory size interrupt
RS232_INT	EQU	014H				;ROM service call for RS232
VIDEO_INT	EQU	010H				;ROM service call for video
KEYBOARD_INT	EQU	016H				;ROM service call for keyboard
DSK_INT		EQU	13h				;ROM service call for disk
TIMER_INT	EQU	1Ah				;ROM service call for timer
PRINTER_INT	EQU	17h
		
		;LPT AND COM
LPT_INIT_CMD	EQU	1				;LPT initialize command to ROM
COM_INIT_CMD	EQU	0				;COM initialize command to ROM
COM_VALUES	EQU	10100011B			;COM initialization values:
							; 2400 baud, no parity
							; 1 stop bit, 8 bit character length
MAX_LPT_NUM	EQU	2				;Maximum supported LPT number
MAX_COM_NUM	EQU	1				;Maximum supported COM number
LPT_INT		EQU	17H				;LPT ROM interrupt
COM_INT		EQU	14H				;COM ROM interrupt

		;DISK
READ_CMD	EQU	2				;Read command
HD_PARAM_CMD	EQU	8				;Get hard disk parameters command

BOOT_LEN	EQU	1				;Length of boot code (in sectors)
BOOT_TRK_SEC	EQU	0001				;Boot track = 0, sector = 1

DRV_MASK	EQU	0C0H				;Equipment check drive mask

BUFFER		EQU	7C00H				;DMA Buffer address

		;HARD DISK EQUATES
HD_DRV_0	EQU	80H				;ROM hard disk drive 0 code
HD_SEC_SIZE	EQU	512				;Hard disk sector size
HD_RES_SEC	EQU	1				;Hard disk number of reserved sectors
HD_NUM_FAT	EQU	2				;Hard disk number of FAT's
HD_MEDIA	EQU	0F8H				;Hard disk media byte

CODE_VAL	EQU	0AA55H				;Validation code on hard disk boot sector
CODE_LOC	EQU	HD_SEC_SIZE - 2			;Offset to validation code in boot sector
							; (last 2 bytes of sector)
SEARCH_START	EQU	1C2H				;Offset in boot sector to start address
							; for search for disk info
INFO_FLAG	EQU	1				;Value to search for to indicate start of
							; information block
INFO_LENGTH	EQU	10H				;Length of information block
OFF_HIDDEN	EQU	4				;Offset from INFO_FLAG to number of hidden 
							; sectors
OFF_SEC		EQU	8				;Offset from INFO_FLAG to total number of
							; sectors
LEAST_SECTORS	EQU	40H				;Smallest number of allowable total sectors 							; for hard disk support

SEC_MASK	EQU	3FH				;Mask for sector bits returned by hard disk

EOF_MARKER	EQU	0FFFH				;FAT End of file marker

		;DIRECTORY VALUES
DIRECTORY	EQU	500H				;Offset to directory for INIT 
							; (assuming segment = 0)
FILE_2_CLUST	EQU	3AH				;Offset to File 2 start cluster number
							; from start of diredtory area
BREAK_CHAR	EQU	'C'-40H				;Keyboard break character

MAX_SYS_LEN	EQU	100H				;Assumed maximum number of paragraphs used by
							; SYS_INIT code

		;INTERRUPT ADDRESSES
INT13_ADDR	EQU	013H * 4			;DISK INTERRUPT ADDR
KEY_BRK_ADDR	EQU	01BH * 4			;Keyboard interrupt address
INT29_ADDR	EQU	029H * 4			;Int 29 = Console output
DSK_PARM_ADDR	EQU	01EH * 4			;Diskette Parameters 
SNGL_STEP_ADDR	EQU	001H * 4			;Single Step Interrupt Address
BRKPOINT_ADDR	EQU	003H * 4			;Breakpoint Interrupt Address
OVERFLOW_ADDR	EQU	004H * 4			;Overflow Interrupt Address
PRNT_ADDR	EQU	00FH * 4			;Printer Interrupt Address

;******************************************************** 1/24/85 NF

timer1_addr	equ	071h * 4			;Software timer#1 interrupt address
IBM_timer_addr	equ	008h * 4

;********************************************************

	;INIT Request header equates
REQ_LEN		EQU	22				;Length of request header
READ_CODE	EQU	4				;Command code to read
BPB_CODE	EQU	2				;Command code to get BPB
;
;	I/O VECTOR (request) constants
;
BAD_CMD		EQU	0BH		;Illegal I/O command code

STAT_DONE	EQU	01		;Done status
STAT_BUSY	EQU	03		;Busy status
STAT_ERR_DONE	EQU	081H		;Error and Done status

ERR_CMD		EQU	03		;Command error
ERR_WRIT_FAULT	EQU	0AH		;Write fault
ERR_READ_FAULT	EQU	0BH		;Read fault
;
;	Device header constants
;
HANDLERS_SEG	EQU	070H		;Segment initialization
CHAR_DEV	EQU	08000H		;Character
CHAR_IO_DEV	EQU	08013H		;Character/std. input/std. output
NULL		EQU	-1		;Null pointer -- last device header
;
;	DOS interrupts
;
CONWRITE_INT	EQU	029H		;ROM service call for keyboard
;
;	RS232 port status constants
;
RSL_DSR		EQU	20H		;Test data set ready (modem)
RSH_TS_REG	EQU	20H		;Test trans shift register (line)
RSH_DATA_READY	EQU	01H		;Test data ready (line)
RSH_TIMEOUT	EQU	80H		;Test timeout (line)
RSH_FR_PAR_OVR	EQU	0EH		;Test framing/parity/overrun (line)
;
;	RS232 I/O constants (INT 14)
;
RS232_WRITE	EQU	01		;Write to RS232 port
RS232_READ	EQU	02		;Read from RS232 port
RS232_STATUS	EQU	03		;Get status of RS232 port
;
;	CONSOLE I/O constants (INT 16)
;
CONSOLE_READ	EQU	00		;Read console
CONSOLE_STATUS	EQU	01		;Get status of console
;
;	Video I/O constants
;
VIDEO_WRIT_TTY	EQU	0EH		;Write to teletype
VIDEO_FOR_COLOR	EQU	0007H		;Set forground color
;

RECAL_CMD	EQU	00h			;Recalibrate disk command
WRITE_CMD	EQU	03h			;Write disk command to ROM
VERIFY_CMD	EQU	04h			;Verify command to ROM

VERIFY_MSK	EQU	10000000b		;Verify bit used by BIOS

NRETRY		EQU	5			;Disk xfers will perform 5 retries

ROM_HD0		EQU	80h			;ROM unit code for first hard disk


CR		EQU	0Dh
LF		EQU	0Ah

REMOV_MED	EQU	00000100b		;Removable media bit in media byte



;	Errors returned from ROM


TIME_OUT	EQU	80h
BAD_SEEK	EQU	40h
BAD_NEC		EQU	20h
BAD_CRC		EQU	10h
DMA_BOUNDRY	EQU	09h
BAD_DMA		EQU	08h
REC_NOT_FND	EQU	04h
WRT_PROTECT	EQU	03h
BAD_ADDR_MARK	EQU	02h
BAD_CMMD	EQU	01h



;	I/O Card #'s
;
CARD_NO_0	EQU	00		;Card # 0 
CARD_NO_1	EQU	01		;Card # 1
CARD_NO_2	EQU	02		;Card # 2
;
;	Print screen constants
;
PRNSC_ROM	EQU	07200H		;Value from ROM for CRTL/SHIFT/PRN SC
PRNSC_ASCII	EQU	010H		;Ascii value for PRN SC



		PAGE
CSEG	SEGMENT PARA PUBLIC 'CODE'
	ASSUME	CS:CSEG,DS:CSEG,ES:CSEG

PUBLIC	RE_INIT				;Required by MS_DOS


BEGIN:
		JMP	INIT				;Go initialize
						
		PAGE


;*************************************************************************
;**									**
;**			DATA STRUCTURES USED				**
;**									**
;*************************************************************************

		;DISK PARAMETER TABLE USED BY ROM
DISK_PARAMS:	DB	0DFH				;Step rate = 6ms,Head unload = 240 ms
		DB	2				;Head load = 1, mode = DMA
		DB	25H				;Wait 25H ms after operation for motor off
		DB	2				;512 bytes/sector
		DB	9				;9 sectors/track
		DB	2AH				;Gap length
		DB	0FFH				;DTL
		DB	50H				;Gap length for format
		DB	0F6H				;Fill byte for format
		DB	00				;Head settle time
		DB	02				;Motor start time = 1/4 second
	PAGE

;	CON DEVICE HEADER --

;	NEXT HEADER	OFFSET = AUX_DEV_HEAD
;			SEGMENT
;	ATTRIBUTE	8013 = CHAR DEVICE / STD. IN / STD. OUT
;	PTR STRATEGY	
;	PTR INTERUPT	
;	NAME		'CON     '
CON_DEV		LABEL	WORD

CON_OFF_NEXT	DW	AUX_DEV
CON_SEG_NEXT	DW	HANDLERS_SEG
CON_ATTR	DW	CHAR_IO_DEV
CON_STRAT	DW	STRATEGY
CON_HANDLER	DW	CON_INT
CON_NAME	DB	'CON     '


;	AUX DEVICE HEADER --

;	NEXT HEADER	OFFSET = COM1_DEV_HEAD
;			SEGMENT
;	ATTRIBUTE	8000 = CHAR DEVICE
;	PTR STRATEGY	
;	PTR INTERUPT	
;	NAME		'AUX     '
AUX_DEV		LABEL	WORD

AUX_OFF_NEXT	DW	PRN_DEV
AUX_SEG_NEXT	DW	HANDLERS_SEG
AUX_ATTR	DW	CHAR_DEV
AUX_STRAT	DW	STRATEGY
AUX_HANDLER	DW	AUX_INT
AUX_NAME	DB	'AUX     '

PRN_DEV		DW	CLK_DEV
		DW	HANDLERS_SEG
		DW	8000h
		DW	STRATEGY
		DW	PRN_INT
		DB	'PRN     '

CLK_DEV		DW	DISK_DEV
		DW	HANDLERS_SEG
		DW	8008h
		DW	STRATEGY
		DW	CLOCK_INT
		DB	'CLOCK$  '

DISK_DEV	DW	COM1_DEV		;Link to next device
		DW	HANDLERS_SEG
		DW	0			;Block device
		DW	STRAT			;Stratagy routine
		DW	DISK_INT		;Interrupt routine

MAXDRV		DB	2
		DB	7 DUP (0)		;8 Byte name field (# of units)

;	COM1 DEVICE HEADER --

;	NEXT HEADER	OFFSET = COM2_DEV_HEAD
;			SEGMENT
;	ATTRIBUTE	8000 = CHAR DEVICE
;	PTR STRATEGY	
;	PTR INTERUPT	
;	NAME		'COM1    '
COM1_DEV	LABEL	WORD

COM1_OFF_NEXT	DW	LPT1_DEV
COM1_SEG_NEXT	DW	HANDLERS_SEG
COM1_ATTR	DW	CHAR_DEV
COM1_STRAT	DW	STRATEGY
COM1_HANDLER	DW	AUX_INT
COM1_NAME	DB	'COM1    '



LPT1_DEV	DW	LPT2_DEV
		DW	HANDLERS_SEG
		DW	8000h
		DW	STRATEGY
		DW	PRN_INT
		DB	'LPT1    '

LPT2_DEV	DW	LPT3_DEV
		DW	HANDLERS_SEG
		DW	8000h
		DW	STRATEGY
		DW	LPT2_INT
		DB	'LPT2    '

LPT3_DEV	DW	COM2_DEV
		DW	HANDLERS_SEG
		DW	8000h
		DW	STRATEGY
		DW	LPT3_INT
		DB	'LPT3    '

;	COM2 DEVICE HEADER --

;	NEXT HEADER	OFFSET = -1 (NULL)
;			SEGMENT
;	ATTRIBUTE	8000 = CHAR DEVICE
;	PTR STRATEGY	
;	PTR INTERUPT	
;	NAME		'COM2    '
COM2_DEV	LABEL	WORD

COM2_OFF_NEXT	DW	NULL
COM2_SEG_NEXT	DW	HANDLERS_SEG
COM2_ATTR	DW	CHAR_DEV
COM2_STRAT	DW	STRATEGY
COM2_HANDLER	DW	COM2_INT
COM2_NAME	DB	'COM2    '

		PAGE


;
;	I/O VECTOR (REQUEST):
;
IOCMD		STRUC

CMD_LEN		DB	0			;Length of this command
CMD_UNIT	DB	0			;Unit code
CMD_CODE	DB	0			;Command code
CMD_STAT	DW	0			;Status
		DW	0,0,0,0			;Reserved

;	End of 13 byte REQUEST VECTOR (HEADER)
;	Start of optional parameters

CMD_MED		DB	0			;Media
CMD_ADDR	DD	0			;Transfer address
CMD_CNT		DW	0			;Count of blocks or characters
CMD_SEC		DW	0			;Starting logical sector

IOCMD		ENDS
		PAGE

;
;	POINTER TO I/O REQUEST HEADER
;
IO_VECTOR	LABEL	DWORD
VECTOR_OFF	DW	?
VECTOR_SEG	DW	?

;
;	CURRENT COM CARD NUMBER
;
CURENT_CARD_NO	DB	0

;
;	1 byte buffer for CARD #0
;	1 byte buffer for CARD #1
;
CARD_0_BUF	DB	0
CARD_1_BUF	DB	0

;
;	1 byte keyboard buffer
;
KEYBOARD_BUF	DB	0
		PAGE

RE_INIT		PROC	FAR

		RET

RE_INIT		ENDP



	SUBTTL INTERRUPT SERVICE ENQUEUE

		PAGE

;
;	STRATEGY ROUTINE
;
;	Entry:
;		ES = Segment of I/O REQUEST HEADER
;		BX = Offset of I/O REQUEST HEADER
;
STRAT		PROC	FAR

STRATEGY:	MOV	CS:VECTOR_OFF,BX		;Save BX
		MOV	CS:VECTOR_SEG,ES		;Save ES
		RET

STRAT		ENDP

		SUBTTL INTERRUPT SERVICE DEQUEUE
		PAGE

;
;	INTERRUPT SERVICE ROUTINE
;


CON_INT PROC	NEAR
		PUSH	SI
		LEA	SI,CON_DSP		;Get offset to start of CON table
		JMP	CMD_EXC			;FALL THRU to execute
CON_INT	ENDP

AUX_INT	PROC	NEAR
 		PUSH	SI
		PUSH	AX
		XOR	AL,AL			;Set COM1 card # = 0
		JMP	OFFSET_AUX		;Go get offset for table
AUX_INT	ENDP

COM2_INT:	PUSH	SI
		PUSH	AX
		MOV	AL,CARD_NO_1		;Set COM2 card # = 1

OFFSET_AUX:	LEA	SI,AUX_DSP		;Get offset to start of AUX/etc. table 
		JMP	CMD_EXC_1		;Go to execute

PRN_INT:	PUSH	SI
		PUSH	AX
		XOR	AL,AL			;Set PRN card # = 0
		JMP	OFFSET_PRN		;Go get offset for table

LPT2_INT:	PUSH	SI
		PUSH	AX
		MOV	AL,CARD_NO_1		;Set LPT2 card # = 1
		JMP	OFFSET_PRN		;Go get offset for table

LPT3_INT:	PUSH	SI
		PUSH	AX
		MOV	AL,CARD_NO_2		;Set LPT3 card # = 2

OFFSET_PRN:	LEA	SI,PRN_DSP		;Get offset to start of PRN/etc. table
		JMP	CMD_EXC_1		;Go to execute

CLOCK_INT:	PUSH	SI
		LEA	SI,CLOCK_DSP		;Get offset to start of CLOCK table
		JMP	CMD_EXC			;Go to execute

DISK_INT:	PUSH	SI
		LEA	SI,DISK_DSP		;Get offset to start of DISK table

;		JMP	CMD_EXC			;Go to execute (FALLS THROUGH)

		PAGE

;
;	COMMAND EXECUTION
;
;	ENTRY:
;		SI = Offset into proper device table

CMD_EXC:	PUSH	AX			;Save all registers

CMD_EXC_1:	PUSH	CX
		PUSH	DX
		PUSH	DI
		PUSH	BP
		PUSH	DS
		PUSH	ES
		PUSH	BX
;
;	Save I/O card #
;
		MOV	[CURENT_CARD_NO],AL	;Save current I/O card #

;
;	Set up parameters for service call
;
		LDS	BX,CS:IO_VECTOR		;Get offset to I/O vector	
		MOV	AL,CMD_UNIT[BX]		;AL = UNITCODE
		MOV	AH,CMD_MED[BX]		;AH = MEDIA
		MOV	CX,CMD_CNT[BX]		;CX = # BLOCKS or CHARS
		MOV	DX,CMD_SEC[BX]		;DX = STARTING LOGICAL SECTOR
		XCHG	DI,AX			;DI = MEDIA/UNITCODE
		MOV	AL,CMD_CODE[BX]		;AL = CMDCODE
		XOR	AH,AH			;AH = 0 -- AX has command code
		ADD	SI,AX			;Form index into proper table
		ADD	SI,AX			;SI = Index into table

		CMP	AL,BAD_CMD		;Check for illegal command code
		JA	CMD_ERROR		;Yes -- command error
		XCHG	DI,AX			;AX = MEDIA/UNITCODE
		LES	DI,DWORD PTR CMD_ADDR[BX]	;DI = TRANSFER ADDRESS offset
						;ES = TRANSFER ADDRESS segment
		PUSH	CS			;Restore DS to current segment
		POP	DS			; DS = CS
;
;	Jump to service routine
;	with parameters as follows:
;
;	AX = MEDIA/UNITCODE
;	CX = # BLOCKS or CHARS
;	DX = STARTING LOGICAL SECTOR
;	DI = TRANSFER ADDRESS offset
;	ES = TRANSFER ADDRESS segment
;	DS = CS = Current code segment


		CALL	WORD PTR [SI]		;Call appropriate routine

;
;	Exit -- Return to caller
;
RET_CALLER	PROC	FAR

		JC	EXIT			;On error go to exit
		MOV	AH,STAT_DONE		;STATUS = done
EXIT:		LDS	BX,CS:IO_VECTOR		;BX = pointer to I/O VECTOR
		MOV	CMD_STAT[BX],AX		;Set STATUS
		POP	BX			;Restore registers --
		POP	ES
		POP	DS
		POP	BP
		POP	DI
		POP	DX
		POP	CX
		POP	AX
		POP	SI
		RET				;Return to caller (FAR)

RET_CALLER	ENDP

		PAGE

;
;	Exit busy
;
BUSY:		MOV	AH,STAT_BUSY		;Set STATUS = busy
		STC				;Exit error
		RET
;
;	COMMAND error
;

CMD_ERROR:	MOV	AL,ERR_CMD		;Set STATUS = command error


RETURN_ERROR:	LDS	BX,CS:IO_VECTOR		;BX = Pointer to I/O VECTOR
		SUB	CMD_CNT[BX],CX		;Update # of bytes transfered
		MOV	AH,STAT_ERR_DONE	;Set STATUS = error/done
		STC				;Exit error
		RET
;
;	Exit with 0 bytes transfered
;
NO_XFER:	LDS	BX,CS:IO_VECTOR		;BX = pointer to I/O VECTOR
		XOR	AX,AX			;Set number of bytes
		MOV	CMD_CNT[BX],AX		; transfered to 0
		RET

		PAGE



DISPATCH_TAB	LABEL	WORD
;
;	DISPATCH TABLE AUX/COM1/COM2
;
;	0	INIT
;	1	MEDIA
;	2	BUILD
;	3	IOCTL
;	4	INPUT (DIS)
;	5	INPUT (NON-DIS)
;	6	INPUT STATUS
;	7	INPUT FLUSH
;	8	OUTPUT
;	9	OUTPUT (VERIFY)
;	10	OUTPUT (STATUS)
;	11	OUTPUT FLUSH
;	12 --	Illegal (not supported)



CON_DSP		DW	DEXIT
		DW	DEXIT
		DW	DEXIT
		DW	CMD_ERROR
		DW	CON_DEST_READ
		DW	CON_NOND_READ
		DW	DEXIT
		DW	CON_IN_FLUSH
		DW	CON_WRITE
		DW	CON_WRITE
		DW	DEXIT
		DW	DEXIT


AUX_DSP		DW	DEXIT
		DW	DEXIT
		DW	DEXIT
		DW	CMD_ERROR
		DW	AUX_DEST_READ
		DW	AUX_NOND_READ
		DW	DEXIT
		DW	AUX_IN_FLUSH
		DW	AUX_WRITE
		DW	AUX_WRITE
		DW	AUX_OUT_STATUS
		DW	DEXIT

PRN_DSP		DW	DEXIT
		DW	DEXIT
		DW	DEXIT	
		DW	CMD_ERROR
		DW	DEXIT
		DW	BUSY
		DW	DEXIT
		DW 	DEXIT
		DW	PRN_WRT
		DW	PRN_WRT
		DW	PRN_STATUS
		DW	DEXIT

CLOCK_DSP	DW	DEXIT
		DW	DEXIT
		DW	DEXIT
		DW	CMD_ERROR
		DW	TIM_RD
		DW	BUSY
		DW	DEXIT
		DW	DEXIT
		DW	TIM_WRT
		DW	TIM_WRT
		DW	DEXIT
		DW	DEXIT

DISK_DSP	DW	DSKINI			;0	Initialize
		DW	MEDCHK			;1	Media check
		DW	GETDPB			;2	Get parameter block
		DW	DERROR			;3	Reserved
		DW	DREAD			;4	Block read
		DW	DBUSY			;5	Character read (return busy)
		DW	DEXIT			;6	Status (not used)
		DW	DEXIT			;7	Flush input buffers (not used)
		DW	DWRITE			;8	Block write
		DW	DWRITEV			;9	Block write with verify
		DW	DEXIT			;10	Output status (not used)
		DW	DEXIT			;11	Flush output buffer (not used)



	SUBTTL CONSOLE I/O DRIVER

		PAGE

;
;	INTERRUPT HANDLER -- CONSOLE
;

;
;	CON read -- Destructive
;
;	Entry:
;		AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;	Exit:

CON_DEST_READ:
		JCXZ	CON_GO_DONE	;If CX (count) = 0 then exit

CON_DEST_LOOP:
		PUSH	CX		;Save count

;	Get keyboard input in AL

		XOR	AX,AX			;Clear AX (AL = 0,Set AH = 0 for keyboard read)
		XCHG	[KEYBOARD_BUF],AL	;AL = char, buffer = 0
		OR	AL,AL			;If buffer not = 0 then
		JNZ	CON_CONT		; buffer was full so return with char

CONSOLE_LOOP:
		INT	KEYBOARD_INT		;Buffer not full -- read keyboard into AL
		OR	AX,AX			;Set flags for testing
		JZ	CONSOLE_LOOP		;If nothing read -- try again

		CMP	AX,PRNSC_ROM		;Check scan code = CTRL/SHIFT/PRT SC
		JNZ	NOT_PRTSC		;If not PRTSC then skip next instr.

		MOV	AL,PRNSC_ASCII		;AL = ascii code for PRTSC

;	An ascii code of 0 is returned from the ROM in AL if the key (or
;	key combination) processed can not be represented
;	with standard ascii codes -- when this happens,
;	a 0 is returned followed by the scan code. A list of the keys
;	that cause this to happen can be found in the basic manual (p. G7).

NOT_PRTSC:
		OR	AL,AL			;Set flags -- If ascii code not = 0
		JNZ	CON_CONT		; then return ascii code

		MOV	[KEYBOARD_BUF],AH	;else return 0 and set up to return scan code

CON_CONT:
		POP	CX		;Restore count
		STOSB			;Store AL > [DI], adjust DI by 1
		LOOP	CON_DEST_LOOP	;Continue until CX (count) = 0

CON_GO_DONE:
		CLC
		RET			;Exit done

		PAGE

;
;	CON read -- Non-destructive
;
;	Entry:
;		AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;	Exit:

CON_NOND_READ:
		MOV	AL,KEYBOARD_BUF		;Get char in keyboard buffer
		OR	AL,AL			;If something is there
		JNZ	CON_RETURN_BYTE		; then return it

CON_NOND_LOOP:
		MOV	AH,CONSOLE_STATUS	;No char in buffer so see if anything at console
		INT	KEYBOARD_INT		;Check console
		JZ	CON_RETURN_BUSY		;If nothing at console then exit busy

		OR	AX,AX			;If char returned is not = 0
		JNZ	CHECK_PRNSC		; then see if it is a CTRL/SHIFT/PRN SC

		MOV	AH,CONSOLE_READ		;Char returned is 0 so set up remove it
		INT	KEYBOARD_INT		; from the console buffer by reading it
		JMP	CON_NOND_LOOP		;Check for more chars

CHECK_PRNSC:
		CMP	AX,PRNSC_ROM		;If char returned is not a PRNSC
		JNZ	CON_RETURN_BYTE		; then skip next instr.

		MOV	AL,PRNSC_ASCII		;AL = ascii code for PRNSC

CON_RETURN_BYTE:
		LDS	BX,CS:IO_VECTOR		;Get xfer address
		MOV	CMD_MED[BX],AL		;Xfer the byte read
		CLC
		RET				;Exit done

CON_RETURN_BUSY:
		JMP	BUSY			;exit busy

		PAGE

;
;	CON input flush
;
;	Entry:
;		AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;	Exit:
;		Console buffers flushed

CON_IN_FLUSH:
		MOV	AH,CONSOLE_STATUS	;See if anything is in the console buffer
		INT	KEYBOARD_INT		;Read console (nondistructive)
		JZ	BUFFER_FLUSHED		;If console buffer is empty then exit

		MOV	AH,CONSOLE_READ		;Else remove next keystroke from buffer 
		INT	KEYBOARD_INT		;Read console (distructive)
		JMP	CON_IN_FLUSH		;Repeat until buffer empty

BUFFER_FLUSHED:
		XOR	AL,AL			;Clear Carry & clear buffer
		MOV	KEYBOARD_BUF,AL		;Clear 1 byte internal buffer
		RET				;Return

		PAGE

;
;	CON write (with verify)
;
;	Entry:
;		AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;	Exit:

CON_WRITE:
		JCXZ	CON_WRITE_DONE		;If CX (count) = 0 then exit done

CON_WRITE_LOOP:
		MOV	AL,ES:[DI]		;AL = byte to write
		INC	DI			;Increment xfer address

;	Do video output (Write byte in AL)

		MOV	BX,VIDEO_FOR_COLOR	;Set forground color in graphics mode
		MOV	AH,VIDEO_WRIT_TTY	;Set for write teletype
		INT	VIDEO_INT		;Do video output

		LOOP	CON_WRITE_LOOP		;Loop until CX (count) = 0

CON_WRITE_DONE:
		CLC
		RET				;Exit Done



	SUBTTL	AUX I/O DRIVER

		PAGE

;
;	INTERRUPT HANDLER -- AUX/COM1/COM2
;

;
;	AUX read -- Destructive
;
;	Entry:
;		AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;	Exit:

AUX_DEST_READ:
		JCXZ	AUX_RETURN_DONE		;If CX (count) = 0 then Exit
		CALL	GET_CARD_BUF		;BX = pntr to 1 byte buffer --
						; for current card
		XOR	AX,AX			;clear AX
		XCHG	[BX],AL			;AL = char,buffer = 0
		OR	AL,AL			;If buffer not = 0 then
		JNZ	SAVE_BUF		; buffer was full so save byte

AUX_READ_LOOP:
		CALL	READ_RS232		;Buffer not full -- read device into AL
		JC	AUX_RETURN_ERROR	;If error in read then exit with error

SAVE_BUF:
		STOSB				;store AL > [DI],adjust DI by 1
		LOOP	AUX_READ_LOOP		;Loop until CX = 0
		CLC
		RET				;RETURN

AUX_RETURN_ERROR:
		JMP	RETURN_ERROR		;Exit error

		PAGE

;
;	AUX read -- Non-distructive
;
;	Entry:
;		AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;	Exit:

AUX_NOND_READ:
		CALL	GET_CARD_BUF		;BX = Pntr to 1 byte buffer --
						; for current card
		MOV	AL,[BX]			;Read buffer but leave char
		OR	AL,AL			;If buffer not = 0 then --
		JNZ	AUX_RETURN_BYTE		; buffer is full so return with AL = next byte

		CALL	GET_STATUS		;Read status of RS232 port
		TEST	AH,RSH_DATA_READY	;If data not ready then (line status)
		JZ	AUX_RETURN_BUSY		; exit busy/done
 
		TEST	AL,RSL_DSR		;If not data set ready (modem status)
		JZ	AUX_RETURN_BUSY		; exit busy/done

		CALL	READ_RS232		;Read RS232 port
		JC	AUX_RETURN_ERROR	;If error in read then exit with error

		CALL	GET_CARD_BUF		;Get pointer to 1 byte buf for current card
		MOV	[BX],AL			;Put byte read into buffer

AUX_RETURN_BYTE:
		LDS	BX,CS:IO_VECTOR		;Get I/O VECTOR offset
		MOV	CMD_MED[BX],AL		;Return byte read in MEDIA byte
		CLC
		RET				;Exit done

AUX_RETURN_BUSY:
		JMP	BUSY			;Exit busy/done

		PAGE

;
;	AUX output status
;
;	Entry:
;		AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;	Exit:

AUX_OUT_STATUS:
		CALL	GET_STATUS		;Read status of RS232 port

		TEST	AL,RSL_DSR		;If not data set ready (modem status)
		JZ	AUX_OUT_BUSY		; exit busy/done

		TEST	AH,RSH_TS_REG		;If trans shift register (line status)
		JZ	AUX_OUT_BUSY		; not empty -- exit busy/done

		CLC
		RET				;Exit done

AUX_OUT_BUSY:
		JMP	BUSY			;Exit busy/done
		PAGE

;
;	AUX input flush
;
;	Entry:
;		AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;	Exit:

AUX_IN_FLUSH:
		CALL	GET_CARD_BUF		;Get pointer to 1 byte buf for current card
		MOV	BYTE PTR [BX],00	;Flush (clear) buffer
		CLC
		RET				;Exit done

		PAGE

;
;	AUX write (with verify)
;
;	Entry:
;		AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;	Exit:

AUX_WRITE:
		JCXZ	AUX_RETURN_DONE		;If byte count = 0 then exit done

AUX_WRITE_LOOP:
		MOV	AL,ES:[DI]		;Get byte to write
		INC	DI			;Bump transfer address
		MOV	AH,RS232_WRITE		;Set up to write char to RS232 port
		CALL	RS232_IO		;Write char to RS232 port
		TEST	AH,RSH_TIMEOUT		;If not timeout then
		JZ	CHECK_COUNT		; check for done

		MOV	AL,ERR_WRIT_FAULT	;Timeout occured --
		JMP	RETURN_ERROR		; Exit error (write fault)

CHECK_COUNT:
		LOOP	AUX_WRITE_LOOP		;If not done then loop to write next

AUX_RETURN_DONE:
		CLC
		RET				;Exit done


	SUBTTL	PRINTER I/O DRIVERS
		PAGE


RETRY_FLAG	DB	0

PRN_WRT:

		JCXZ	PRN_RETURN_DONE		;If CX (count) = 0 then exit done

PRN_WRITE_LOOP:
		MOV	AL,ES:[DI]		;Get byte to write to printer
		INC	DI			;Increment xfer address
		MOV	RETRY_FLAG,00		;Clear RETRY_FLAG

PRN_WRITE_RETRY:
		XOR	AH,AH			;Set up to print character in AL
		CALL	PRINTER_IO		;Print character in AL
		JZ	PRN_CHECK_LOOP		;No error -- see if done with xfer

		XOR	RETRY_FLAG,01		;Error in print -- if it was time out
		JNZ	PRN_WRITE_RETRY		; then retry with same char

		JMP	RETURN_ERROR		;If any other error then return it

PRN_CHECK_LOOP:
		LOOP	PRN_WRITE_LOOP		;Continue until CX (count) = 0

PRN_RETURN_DONE:
		RET				;Exit done

PRN_RETURN_ERROR:
		JMP	RETURN_ERROR

PRN_RETURN_BUSY:
		JMP	BUSY

PRN_STATUS:
		CALL	GET_STAT		;Get printer status 
		JNZ	PRN_RETURN_ERROR	;If error then return it
		TEST	AH,80h			;If printer busy then
		JZ	PRN_RETURN_BUSY		; return busy
		RET				;Else return done

;
;	Do printer port I/O
;	Entry:
;		AH = 0	Print char in AL
;		AH = 1	Initialize the printer port
;		AH = 2	Read status of printer port into AH
;		DX = 0 or 1	Current card #
;	Exit:
;		AH = Status	Printer status (TECH MAN p. A-42)
;	If error --
;		Z flag clear
;		AL = error code to return in I/O vector status byte
;	If no error --
;		Z flag set

GET_STAT:	MOV	AH,02			;Set up to get printer status

PRINTER_IO:	CALL	GET_CARD		;Set DX = current card #
		INT	PRINTER_INT		;Perform printer port I/O

		MOV	AL,02			;Set up to return status = Dev not ready
		TEST	AH,01			;If time out occured
		JNZ	PRINTER_IO_RET		; then return with that status

		MOV	AL,0Ah			;Set up to return status = write fault
		TEST	AH,08h			;Check if device busy
		JZ	PRINTER_IO_RET		;If not busy then return

		TEST	AH,20h			;If device busy -- check out of paper
		JZ	CLEAR_Z_FLAG		;If not out of paper then return write fault

		MOV	AL,09h			;If out of paper then set up to return
						; status = out of paper
CLEAR_Z_FLAG:	OR	AL,AL			;Clear Z bit to indicate error status

PRINTER_IO_RET:	RET				;Return

	SUBTTL CHARACTER I/O SUPPORT ROUTINES
		PAGE

;
;	Return pointer to 1 byte buffer for
;	current card
;	Entry:
;		None
;	Exit:
;		DX = 0 or 1	Current card #
;		BX = 		Pointer to 1 byte buffer for current card
;

GET_CARD_BUF:
		CALL	GET_CARD		;Get card # in DX
		LEA	BX,CARD_0_BUF		;Get pointer to buffer for --
		ADD	BX,DX			; current card
		RET				;Return

		PAGE

;
;	Read RS232 port and check for errors
;	Entry:
;		None
;	Exit: (If no error on read)
;		AL    =	Char read from RS232 port
;		Carry =	Clear
;	Exit: (If error on read)
;		AL    = 0Bh Read fault
;		Carry =	Set
;

READ_RS232:
		MOV	AH,RS232_READ		;Set up for RS232 read to AL
		CALL	RS232_IO		;Read RS232 port
		TEST	AH,RSH_FR_PAR_OVR	;Test for framing/parity/overrun errors
		CLC				;Set return parm for no error
		JZ	READ_RET		;If none of above errors then return

		MOV	AL,ERR_READ_FAULT	;Set STATUS = read fault
		STC				;Set return parm for error

READ_RET:
		RET				;Return

		PAGE

;
;	Do RS232 port I/O
;	Entry parameters for INT RS232_INT:
;		AH = 0	Init RS232 port
;		AH = 1	Sent char in AL to RS232 port
;		AH = 2	Receive char in AL from RS232 port
;		AH = 3	Get status of RS232 port
;		DX = 0 or 1	Current card #
;	Exit:
;		AX = Status	Status of RS232 port (TECH MAN. p. A-23)
;

GET_STATUS:
		MOV	AH,RS232_STATUS		;Set up to read RS232 port status

RS232_IO:
		CALL	GET_CARD		;Set DX = Card #
		PUSH	BP		
		INT	RS232_INT		;Perform RS232 port I/O
		POP	BP
		RET				;Return

		PAGE

;
;	Get RS232 card # in DX
;	Entry:
;		None
;	Exit:
;		DX = 0 or 1	RS232 card #
;

GET_CARD:
		MOV	DL,[CURENT_CARD_NO]	;DL = card #
		XOR	DH,DH			;DL = 0, DX = card # (0 or 1)
		RET

	SUBTTL CLOCK DRIVER
		PAGE


; THIS IS THE ENTRY POINT TO THE CLOCK DRIVER
; ON ENTRY :
;		ES:DI POINTS TO THE DATA TRANSFER ADDRESS	

	IF	RTC


	IF2	
%OUT	REAL TIME CLOCK$ DRIVER VERSION
	ENDIF


clock_block	db	7 dup(0)
leap_word	dw	month_table
ten		db	10
;
;
time_of_day	equ	1ah
;
;
tim_rd:
	cld
	push	es
	mov	ax,cs
	mov	es,ax
; read calender
	mov	ah,2			;set function number
	mov	bx,offset clock_block
	int	time_of_day
	pop	es
	and	byte ptr [bx+2],00111111b       ;mask out higher two bits of hour
	mov	al,[bx+4]		;get day of month
	mov	word ptr [leap_word],offset month_table
	test	al,01000000b		;is it a leap year
	jz	tim10
	mov	word ptr [leap_word],offset leap_table
tim10:
	and	al,00111111b		;mask out higher 2 bits of day of month
	mov	byte ptr [bx+4],al
; convert BCD to binary
	mov 	cx,7			;set loop counter
tim11:
	mov	al,ds:[bx]
	call	bcd_to_binary
	mov	ds:[bx],al
	inc	bx
	loop	tim11	
; calculate days from 1,1,1980
	mov	bx,offset clock_block
	mov	al,ds:[bx+6]		;get year
	sub	al,80			;day begin from 1980
	xor	dx,dx			;dx is total day
	or	al,al			;is al is zero
	jz	tim13
tim14:
	add	dx,366
	dec	al
	jz	tim13
	add	dx,365
	dec	al
	jz	tim13
	add	dx,365
	dec	al
	jz	tim13
	add	dx,365
	dec	al
	jnz	tim14
tim13:
	mov	si,word ptr [leap_word]
	mov	al,ds:[bx+5]		;get month byte
	dec	al
	sal	al,1
	sub	ah,ah	 	
	add	si,ax
	add	dx,[si]			;add month
	mov	al,[bx+4]		;get day
	add	ax,dx			;add day
	dec	ax			;dos take 1/1/80 as 0
	stosw				;set days
	mov	al,[bx+1]		;get minute
	stosb	
	mov	al,[bx+2]		;get hour
	stosb
	mov	al,0			;get seconds
	stosb				;set hundreds of sec
	mov	al,[bx]
	stosb				;set sec
	clc
	ret
;
month_table	dw	0,31,59,90,120,151,181,212,243,273,304,334
;
leap_table	dw	0,31,60,91,121,152,182,213,244,274,305,335
;
; this routine convert the bcd code to binary
; input
;	al : packed bcd
; output
;	al : binary
;
bcd_to_binary	proc	near
	push	cx
	mov	ch,al		
	and	ch,0fh			;save lower nibble
	mov	cl,4
	shr	al,cl			
	mul	[ten]
	add	al,ch
	pop	cx
	ret
bcd_to_binary	endp


tim_wrt:
	mov	dx,es:[di]		;get day
	inc	dx
	xor	al,al			;al is count of year
tim20:
	cmp	dx,366
	jc	tim21
	inc	al
	sub	dx,366
	cmp	dx,365
	jc	tim21
	inc	al
	sub	dx,365
	cmp	dx,365
	jc	tim21
	inc	al
	sub	dx,365
	cmp	dx,365
	jc	tim21
	inc	al
	sub	dx,365
	jmp	tim20
tim21:
	mov	bx,offset clock_block
	mov	word ptr [leap_word],offset month_table
	test	al,00000011b			;is it  a leap year
	jnz	tim22
	mov	word ptr [leap_word],offset leap_table  	;yes
tim22:
	add	al,80			;date in dos start from 1980
	mov	byte ptr [bx+6],al		;save year in clock block
; calculate month of year
	mov	si,word ptr [leap_word] 
	mov 	al,1			;al is month of year
tim23:
	inc	si
	inc	si
	cmp	dx,[si]
	jc	tim24
	inc	al
	jmp	tim23
;
tim24:
	dec	si
	dec	si
	sub	dx,[si]			;dx is day of month
	mov	byte ptr [bx+5],al
	mov	byte ptr [bx+4],dl	
	mov	al,es:[di+5]		;get sec
	mov	byte ptr [bx],al	;save it
	mov	al,es:[di+2]		;get minutes
	mov	byte ptr [bx+1],al
	mov	al,es:[di+3]		;get hour
	mov	byte ptr [bx+2],al
; convert binary to BCD
	mov	cx,7
tim25:
	mov	al,ds:[bx]
	call 	binary_to_bcd
	mov	ds:[bx],al
	inc	bx
	loop	tim25
;
	mov	bx,offset clock_block
	push	cs
	pop	es
	or	byte ptr [bx+2],10000000b		;set high bit
; write calender
	mov	ah,3

;*****************************************************************
;
;
;	REMOVED THE FOLLOWING INTERRUPT AND REPLACED BY INLINE CODE
;	FROM  TIMDAY11.ASM.
;
;	int	time_of_day
;
;-----------------------------------------------------------------------
;
address_port	equ	3DH		; calender clock chip, write only
data_port	equ	3CH		; ditto, read/write.
set_mask	equ	80H		; set time bit of register B
table_length	equ	7

		jmp	t3


ram_address_table	db	0, 2, 4, 6, 7, 8, 9
					; calender ram addresses
;	ENTRY:
;                        (BX) pointer to calender clock parameter
;                             block.
;                        (ES) data segment of pointer.
;
;
;		CALENDER CLOCK PARAMETER BLOCK LAYOUT FOR REQUEST 3
;
;			If any of bytes 0..6 below = FFH,
;			then its corresponding HD146818 register will
;			not be changed.
;
;                        BYTE FIELD
;                        0    seconds (do not care, always set to zero).
;                        1    minutes (range 0..59 BCD).
;                        2    hours (range 0..23 BCD ignoring bits ab).
;				bit fields abccdddd (high to low bits)
;				a = 0  if 12 hour time (hours range 1..12 BCD)
;					b = 0  if AM
;					b = 1  if PM
;					cc =	upper hour digit (range 0..1)
;					dddd =	lower hour digit (range 0..9)
;				a = 1  if 24 hour time (hours range 0..23 BCD)
;					b = do not care
;					cc =	upper hour digit (range 0..2)
;					dddd =	lower hour digit (range 0..9)
;                        3    day of week (range 0..6).
;				0 = Sunday ...
;				6 = Saturday
;                        4    day of month (range 1..31 BCD ignoring bits ab)
;				bit fields abccdddd (high to low bits)
;				a = b = do not care
;				cc =	upper day digit (range 0..3)
;				dddd =	lower day digit (range 0..9)
;                        5    month of year (range 1..12 BCD).
;                        6    lower two digits of year (range 00..99 BCD).
;				(assumed current century is 1900)
;
;
;    ACTION:    This in-line code writes the calender clock.
;		(AH = 3)
;		     Parameter block interpreted according to conditions
;		     and loaded into selected HD146818 registers.
;
;    EXIT:
;               (AH = 3)
;		     Calender clock parameter block preserved.
;
;    NOTES:	1.  THE FOLLOWING CODE WILL WORK PERFECTLY AS LONG
;		AS IT IS NOT INVOKED IN THE MIDDLE OF A ROM BIOS
;		CALL TO INT 1AH (FCT 2 OR 3), OR VICE-VERSA.
;		IF THAT HAPPENS, I DO NOT THINK IT WILL CRASH MACHINE
;		BUT ONLY MIXUP THE CURRENT DATE.  HOPEFULLY, THIS
;		WILL NEVER HAPPEN!
;
;		2.  Incompatible to VENUS ROM BIOS:
;			-  only difference is that seconds are not always
;			-  set to zero.

					;-------------------------------
t3:					; write calender clock
					;-------------------------------
		push	cx
		push	si
;***** 1/21/85
;		sti			; let other interrupts in
		mov	al, 0BH
		out	address_port, al
		in	al, data_port	; read register B of chip

		or	al, set_mask
		out	data_port, al	; write reg B with set bit on.

		mov	si, 0
		mov	cx, table_length
t3_byte:
		mov	al, cs:ram_address_table[si]
		out	address_port, al
		mov	al, es:[bx][si]

		; meet VENUS entry conditions with fall through cases:

		cmp	al, 0FFH		; for any field,
		je	t3_skip			; skip register write if =FFH

		cmp	si, 0			; always set seconds to zero
		jne	t3_skip0
;		xor	al, al		;******  disabled 1/21/85

t3_skip0:	cmp	si, 2			; modify hours field
		jne	t3_skip1
		test	al, 80H
		jnz	t3_mask			; jump if a = 1

		; convert 12 hour time to 24 hour time as follows:
		;	1..11 AM  -->  1..11
		;	12 AM	  -->  0
		;	1..11 PM  -->  13..23
		;	12 PM	  -->  12

		cmp	al, 12H
		jb	t3_mask			; jmp if 1..11 AM
		jne	t3_pm
		xor	al, al			; 12 AM
		jmp	short t3_skip1
t3_pm:		cmp	al, 52H
		je	t3_mask			; jmp if 12 PM

		; 1..11 PM
		; Packed BCD addition of 12H is equivalent to binary addition
		; of 12H when (al) in range 41..51, except (al) = 48 or 49.
		; It is equivalent to binary addition of 18H in this case.

t3_normal:	test	al, 8H
		jz	t3_small		; jmp if (al) <> 48 or 49.
		add	al, 6H
t3_small:	add	al, 12H

t3_mask:	and	al, 3FH			; mask out a and b

t3_skip1:	cmp	si, 3			; modify day of week
		jne	t3_skip2
		add	al, 1

t3_skip2:	cmp	si, 4			; modify day of month
		jne	t3_skip3
		and	al, 3FH			; mask out a and b

t3_skip3:	; finished with modification, set calender register

		out	data_port, al
t3_skip:	inc	si
		loop	t3_byte

		mov	al, 0BH
		out	address_port, al
		in	al, data_port		; read reg B
		and	al, not set_mask
		out	data_port, al		; write regB with set bit off	

		pop	si
		pop	cx


;*****************************************************************

	clc
	ret
;
binary_to_bcd	proc 	near
	push	cx
	cbw
	idiv	[ten]
	mov	cl,4
	sal	al,cl
	add	al,ah
	pop	cx
	ret
binary_to_bcd	endp
;

	ELSE
	IF2
%OUT	STANDARD CLOCK$ DRIVER VERSION
	ENDIF
CLK_BUF		DW	0			; 2 BYTE BUFFER USED BY CLOCK DR

TIM_WRT:	MOV	AX,ES:[DI]		;GET THE CURRENT TIME DATA
		MOV	[CLK_BUF],AX		;STORE IT IN THE LOCAL BUFFER

		XOR	AX,AX			;READ CURENT TIME OF DAY
		INT	TIMER_INT		;FROM THE ROM

		MOV	CX,ES:[DI+02]		;PUT HIGHER WORD OF COUNT INTO CX
		MOV	DX,ES:[DI+04]		;AND LOWER WORD IN DX

		MOV	AL,60			;AL=60 DECIMAL
		MUL	CH			;CONVERT HOURS INTO MIN
		MOV	CH,0			;CLEAR CH
		ADD	AX,CX			;AX NOW EQUALS TOTAL MIN

		MOV	CX,6000			;CX = 6000 DECIMAL = MSEC/MIN
		MOV	BX,DX			;SAVE THE HIGH ORDER COUNT
		MUL	CX			;MULTIPLY TOTAL MIN X MSEC/MIN
						;AND GET TOT NO OF MSEC IN DX,AX

		MOV	CX,AX			;GET LOWER PART OF MSEC
		MOV	AL,100			;FACTOR TO CONVERT INTO MSECS
		MUL	BH			;CONVERT SECONDS TO MSEC
		ADD	CX,AX			;CX NOW CONTAINS TOTAL MSECS
		ADC	DX,00			;GET CARRY BIT IF SET INTO DX
		MOV	BH,00			;CLEAN OUT MIN PART OF BX
		ADD	CX,BX
		ADC	DX,00
		XCHG	DX,AX
		XCHG	CX,AX
		MOV	BX,0E90Bh
		MUL	BX
		XCHG	CX,DX
		XCHG	DX,AX
		MUL	BX
		ADD	AX,CX
		ADC	DX,00
		XCHG	DX,AX
		MOV	BX,0005
		DIV	BL
		MOV	CL,AL
		MOV	CH,00
		MOV	AL,AH
		CBW
		XCHG	DX,AX
		DIV	BX
		MOV	DX,AX
		MOV	AH,01
		INT	TIMER_INT

		CLC
		RET


TIM_RD:		XOR	AX,AX
		INT	TIMER_INT
		ADD	[CLK_BUF],AX
		MOV	AX,CX
		MOV	BX,DX
		SHL	DX,1
		RCL	CX,1
		SHL	DX,1
		RCL	CX,1
		ADD	DX,BX
		ADC	AX,CX
		XCHG	DX,AX
		MOV	CX,0E90Bh
		DIV	CX
		MOV	BX,AX
		XOR	AX,AX
		DIV	CX
		MOV	DX,BX
		MOV	CX,00C8h
		DIV	CX
		CMP	DL,64h
		JB	PROC10

		SUB	DL,64h

PROC10:		CMC
		MOV	BL,DL
		RCL	AX,1
		MOV	DL,00
		RCL	DX,1
		MOV	CX,003Ch
		DIV	CX
		MOV	BH,DL
		DIV	CL
		XCHG	AH,AL
		PUSH	AX
		MOV	AX,[CLK_BUF]
		STOSW
		POP	AX
		STOSW
		MOV	AX,BX
		STOSW

		CLC
		RET 

	ENDIF


	SUBTTL DISK I/O DRIVER

		PAGE


;*******************************************************
;
;	Drive Variables
;
;*******************************************************

;	Errors returned from ROM, Error returned to DOS

ERROR_TBL	DB	80h,02h
		DB	40h,06h
		DB	20h,0Ch
		DB	10h,04h
		DB	09h,0Ch
		DB	08h,0Ch
		DB	04h,08h
		DB	03h,00h
		DB	02h,08h


LAST_LOG_FDD	DB	0			;Last logical unit accessed was "A"

COMMAND		DB	?

DISK		DB	?
SECTOR		DB	?
TRACK		DW	?
HEAD		DB	?

COUNT		DW	?
SECS_XFERD	DW	?
SEC_TO_READ	DW	?
START_SECTOR	DW	?
CMD_AND_SEC	DW	?

LAST_ACCESS_L	DW	0			;Last access for current drive
LAST_ACCESS_H	DW	0

CUR_DRV		DB	0			;Current drive #

NUM_PHY_FDDS	DB	2			;# of physical FDD's filled in by INIT

NUM_LOG_FDDS	DB	2			;# of logical FDD's filled in by INIT


;*******************************************************
;
;	Drive Parameter Block
;
;*******************************************************

DSKDPB		DW	DDDS			;Double-density, double-sided
		DW	DDDS			;Double-density, double-sided
		DW	HD0			;Spare, filled in by BIOS init
		DW	HD1			;Spare, filled in by BIOS init


;*******************************************************
;
;	Drive Parameter Tables
;
;*******************************************************


BPB		STRUC

SEC_SIZE	DW	0
ALLOC_SIZE	DB	0
RES_SEC		DW	0
NUM_FAT		DB	0
NUM_DIR		DW	0
DISK_SIZE	DW	0
MEDIA		DB	0
SEC_FAT		DW	0

SEC_TRK		DW	0
NUM_HEADS	DW	0
HIDDEN_SEC	DW	0

BPB		ENDS

BPB_LEN		EQU	13h


DPBTBL		LABEL	WORD			;Start of Disk Parameter Blocks

;Double-density, single-sided, 8 sectors/track

DDSS		DW	512			;Sector size (in bytes)
		DB	1			;Allocation size (sectors)
		DW	1			;Reserved sectors
		DB	2			;# of FAT's
		DW	64			;Directory entries
		DW	40*8			;Disk size (sectors)
		DB	0FEh			;Media byte
		DW	1			;Sectors in one FAT

		DW	8			;Sectors per track
		DW	1			;# of heads
		DW	0			;# of hidden sectors

;Double-density, double-sided, 8 sectors/track

DDDS		DW	512			;Sector size (in bytes)
		DB	2			;Allocation size (sectors)
		DW	1			;Reserved sectors
		DB	2			;# of FAT's
		DW	112			;Directory entries
		DW	40*8*2			;Disk size (sectors)
		DB	0FFh			;Media byte
		DW	1			;Sectors in one FAT

		DW	8			;Sectors per track
		DW	2			;# of heads
		DW	0			;# of hidden sectors



;Double-density, single-sided, 9 sectors/track

DDSSXT		DW	512			;Sector size (in bytes)
		DB	1			;Allocation size (sectors)
		DW	1			;Reserved sectors
		DB	2			;# of FAT's
		DW	64			;Directory entries
		DW	40*9			;Disk size (sectors)
		DB	0FCh			;Media byte
		DW	2			;Sectors in one FAT

		DW	9			;Sectors per track
		DW	1			;# of heads
		DW	0			;# of hidden sectors

;Double-density, double-sided, 9 sectors/track

DDDSXT		DW	512			;Sector size (in bytes)
		DB	2			;Allocation size (sectors)
		DW	1			;Reserved sectors
		DB	2			;# of FAT's
		DW	112			;Directory entries
		DW	40*9*2			;Disk size (sectors)
		DB	0FDh			;Media byte
		DW	2			;Sectors in one FAT

		DW	9			;Sectors per track
		DW	2			;# of heads
		DW	0			;# of hidden sectors

;Quad-density, single-sided, 8 sectors/track

QDSS  		DW	512			;Sector size (in bytes)
		DB	2	;WAS 1 12/14	;Allocation size (sectors)
				;IBM 5550 SPEC SHEET SAYS "2"
		DW	1			;Reserved sectors
		DB	2			;# of FAT's
		DW	112			;Directory entries
		DW	80*8	;WAS *2	12/14		;Disk size (sectors)
		DB	0FAh			;Media byte
		DW	1	;WAS 4	12/14		;Sectors in one FAT

		DW	8			;Sectors per track
		DW	1			;# of heads
		DW	0			;# of hidden sectors


;Quad-density, double-sided, 8 sectors/track

QDDS  		DW	512			;Sector size (in bytes)
		DB	2			;Allocation size (sectors)
		DW	1			;Reserved sectors
		DB	2			;# of FAT's
		DW	112			;Directory entries
		DW	80*8*2			;Disk size (sectors)
		DB	0FBh			;Media byte
		DW	2			;Sectors in one FAT	RFS

		DW	8			;Sectors per track
		DW	2			;# of heads
		DW	0			;# of hidden sectors

;Quad-density, single-sided, 9 sectors/track
; COMMENTED OUT SO CAN USE IBM HARD DISK STANDARD F8
;QDSSXT		DW	512			;Sector size (in bytes)
; 		DB	2			;Allocation size (sectors)
; 		DW	1			;Reserved sectors
; 		DB	2			;# of FAT's
; 		DW	112			;Directory entries
; 		DW	80*9*1			;Disk size (sectors)
; 		DB	0F8h			;Media byte
; 		DW	4			;Sectors in one FAT
;
; 		DW	9			;Sectors per track
; 		DW	1			;# of heads
; 		DW	0			;# of hidden sectors
;

;Quad-density, double-sided, 9 sectors/track

QDDSXT		DW	512			;Sector size (in bytes)
		DB	2			;Allocation size (sectors)
		DW	1			;Reserved sectors
		DB	2			;# of FAT's
		DW	112			;Directory entries
		DW	80*9*2			;Disk size (sectors)
		DB	0F9h			;Media byte
		DW	3	;WAS 4 12/14	;Sectors in one FAT

		DW	9			;Sectors per track
		DW	2			;# of heads
		DW	0			;# of hidden sectors


;Hard disk #0 BPB, filled in by BIOS INIT

HD0		DW	0			;Sector size (in bytes)
		DB	0			;Allocation size (sectors)
		DW	0			;Reserved sectors
		DB	0			;# of FAT's
		DW	0			;Directory entries
		DW	0			;Disk size (sectors)
		DB	0			;Media byte
		DW	0			;Sectors in one FAT

		DW	0			;Sectors per track
		DW	0			;# of heads
		DW	0			;# of hidden sectors


;Hard disk #1 BPB, filled in by BIOS INIT

HD1		DW	0			;Sector size (in bytes)
		DB	0			;Allocation size (sectors)
		DW	0			;Reserved sectors
		DB	0			;# of FAT's
		DW	0			;Directory entries
		DW	0			;Disk size (sectors)
		DB	0			;Media byte
		DW	0			;Sectors in one FAT

		DW	0			;Sectors per track
		DW	0			;# of heads
		DW	0			;# of hidden sectors


NUMBPB		EQU	09H 			;Number of BPB's




DSKINI:
;0	Initialize
;
;	ENTRY	AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;
;	EXIT	
;

		LDS	BX,IO_VECTOR		;Get I/O Request Header

		MOV	AL,CS:MAXDRV		;Get # of units
		MOV	CMD_MED[BX],AL		;and save for return parameter

		MOV	CMD_CNT[BX],OFFSET DSKDPB
		MOV	CMD_CNT+2[BX],CS	;Pass BPB address and segment

		CLC
		RET				;Return with done status
		PAGE

MEDCHK:
;1	Media check
;
;	ENTRY	AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;
;	EXIT	I/O VECTOR+14 = BYTE Return information
;			   -1 , Media has been changed
;			    0 , Don't know if media has changed
;			    1 , Media has not been changed
;
;
;	ALL MEDIA BESIDES (F8 = HARD DISK) IS CONSIDERED REMOVABLE
;
		MOV	DI,1			;Setup for media not changed
		CMP 	AH,0F8H			;IS IT HARD DISK : F8
;		TEST	AH,REMOV_MED		;Is the media removable?
 		JZ	MED_EXIT		;No, exit

		DEC	DI			;Setup for media unsure
		CMP	AL,CUR_DRV		;Was this the last floppy accessed?
		JNE	MED_EXIT		;No, the media could have changed

;	Now check the elasped time since last transfer to/from this FDD

		XOR	AH,AH			;Set parameter to timer interrupt
		INT	TIMER_INT		;Get # of ticks since power up
						;# ticks returned in CX (HOW) & DX (LOW)
		SUB	DX,LAST_ACCESS_L
		SBB	CX,LAST_ACCESS_H	;Get elasped ticks in CX, DX

		OR	CX,CX			;Check if more than 64K ticks have elasped
		JNZ	MED_EXIT		;Yes, exit with don't know

		CMP	DX,40			;Check to see if elasped > 2 sec
		JA	MED_EXIT		;Yes, then exit unsure

		INC	DI			;Otherwise indicate no change

MED_EXIT:	LDS	BX,IO_VECTOR		;Get I/O Request Header
		MOV	WORD PTR CMD_ADDR[BX],DI	;Save exit parameter

		CLC
		RET
		PAGE

GETDPB:
;2	Get parameter block
;
;	ENTRY	AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;
;	EXIT	I/O VECTOR+18 = DWORD pointer to BPB
;

		MOV	AH,ES:[DI]		;Get first byte of FAT (media descriptor)
		MOV	CL,AH			;Check for valid media byte
		AND	CL,0F8h			;Just check top 5 bits
		CMP	CL,0F8h			;Are they all set?
		JZ	FIND_BPB		;Yes, assume valid

		MOV	AH,0FEh			;No, must be DOS 1.xx, assume 8SPT single-sided

FIND_BPB:	LEA	BX,HD0			;Set return parameter to HD0
		CMP	AL,NUM_LOG_FDDS		;Is this unit a floppy?
		JE	DPB_EXIT		;No, this is HD0, exit

		JB	FIND_FPY_BPB		;Yes, find BPB for this floppy

		LEA	BX,HD1			;No, this unit is HD1
		JMP	DPB_EXIT

FIND_FPY_BPB:	MOV	CX,NUMBPB		;Initialize loop count
		MOV	BX,OFFSET DPBTBL-BPB_LEN

GETIT:		ADD	BX,BPB_LEN		;Point DX to BPB media byte
		CMP	AH,MEDIA[BX]
		LOOPNE	GETIT			;No match and loop not done, goto GETIT

		SHL	AL,1			;Adjust unit # to form index
		LEA	DI,DSKDPB
		XOR	AH,AH
		ADD	DI,AX			;Form pointer in DSKDPB table
		MOV	[DI],BX			;Make entry

DPB_EXIT:	LDS	DI,IO_VECTOR		;Get I/O Vector
		MOV	CMD_CNT[DI],BX		;Save BPB address
		MOV	CMD_SEC[DI],CS		;and segment

		CLC
		RET				;Exit
		PAGE

DERROR:
;3	Reserved

		MOV	AX,8103h		;Indicate invalid command
		STC
		RET
		PAGE


DREAD:
;4	Block read
;
;	ENTRY	AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;

		MOV	COMMAND,READ_CMD	;Read command for INT 13
		JMP	RW_COM			;Go to commmon read/write routine


DBUSY:
;5	Character read (return busy)
;

		MOV	AX,0300h		;Return busy
		STC
		RET


DEXIT:
;6	Status
;7	Flush input buffers
;10	Output status
;11	Flush output buffers

		CLC
		RET




DWRITE:
;8	Block write
;
;	ENTRY	AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;


		MOV	COMMAND,WRITE_CMD	;Indicate write for INT 13
		JMP	RW_COM


DWRITEV:
;9	Block write with verify
;
;	ENTRY	AX = MEDIA/UNITCODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;

		MOV	COMMAND,WRITE_CMD + VERIFY_MSK
		JMP	RW_COM
		PAGE
;------------------------------------------------------------------------------
;RW_COM
;
;Description:
;	This is the common routine for all disk I/O routines.  The DMA chip 
;  uses	a page register and an address register.  This routine must check for
;  DMA page overflow.  If the request to read or write causes a DMA page overflow
;  RW_COM will read as much as it can into the first page.  The next sector may
;  sit partly within one DMA page and partly within the next DMA page.  To read
;  this sector, RW_COM reads the sector into an area that is within a page boundary
;  and then moves the sector to its proper position.  The following sectors will
;  all fall into the next page so RW_COM just reads the rest without checking again
;  for DMA page overflows.
;
;  NOTE:  This routine assumes that no requests will be made which will cause a
;	  segment overflow
;  
;	ENTRY	AX = MEDIA/UNIT CODE
;		CX = # BLOCKS or CHARS
;		DX = STARTING LOGICAL SECTOR
;		DI = TRANSFER ADDRESS offset
;		ES = TRANSFER ADDRESS segment
;		DS = CS = Current code segment
;
;		COMMAND = DSK_INT Command code (see ROM documentation)
;			  with high bit set for verify
;
;	EXIT	C Flag set if error
;		AX = Error code if error
;		Number of sectors transfered stored in IO_VECTOR
;		Time stored in LAST_ACCESS
;------------------------------------------------------------------------------

RW_COM		PROC

		MOV	START_SECTOR,DX			;Save starting sector number
		MOV	SEC_TO_READ,CX			;Save # of sectors to transfer
		MOV	CUR_DRV,AL			;Save unit #
		MOV	SECS_XFERD,0			;No sectors transfered yet
		MOV	BX,DI				;Transfer buffer is ES:BX

;GET BPB ADDRESS
		LEA	DI,DSKDPB			;Let's find the correct BPB  
		ADD	AL,AL				;Form offset into table
		XOR	AH,AH				;AX = table offset
		ADD	DI,AX				;Get table location
		MOV	DI,[DI]				;Now, DI points to correct BPB

;GET DMA PAGE OFFSET
		MOV	AX,ES				;Get DMA segment
		MOV	CL,4			
		SHL	AX,CL				;Shift offset bits to correct 
							;  position
		ADD	AX,BX				;AX = Address within DMA page

		PAGE
;GET MAXIMUM NUMBER OF SECTORS TO READ ON THIS PAGE

	;GET START SECTOR NUMBER
		MOV	CX,SEC_SIZE[DI]			;CX = Sector size
		DEC	CX
		ADD	AX,CX				;AX = Last byte address of sector
		JC	NEXT_PAGE			;If page overflow, then no room to 
							;  read any sectors in this page,
							;  go to next page
		XOR	DX,DX				;Clear for divide
		INC	CX				;Set CX = Sector size
		DIV	CX				;AX = DMA Start sector number
							;  within page
	;GET TOTAL NUMBER OF SECTORS IN PAGE
		PUSH	AX				;Save start sector
		MOV	AX,8000H			;Page length/2
		XOR	DX,DX				;Clear for divide
		SHR	CX,1				;Sector length/2	
		DIV	CX				;AX = Number of sectors in page
		MOV	CX,AX				;CX = Number of sectors in page
		POP	AX				;AX = Start sector number

	;GET NUMBER OF SECTORS WHICH CAN BE READ IN THIS PAGE
		SUB	CX,AX				;CX = Maximum number of sectors 
							;  to read
;SET NUMBER OF SECTORS TO READ THIS TIME
		CMP	CX,SEC_TO_READ			;Check if all sectors fit on 
							;  this page
		JBE	RW1				;If all don't fit, only read the 
							;  sectors on this page
		MOV	CX,SEC_TO_READ			;CX = Number of sectors to read

;READ SECTORS FROM THIS PAGE
RW1:		MOV	DX,START_SECTOR			;DX = Logical start sector
		CALL	READ_WRITE			;Read or write sectors on page
		JC	RW_DONE				;Done if error

		ADD	DX,CX				;DX = Logical start sector for 
							;  next read
		SUB	SEC_TO_READ,CX			;Set # of sectors left to read
		JZ	RW_DONE				;Done if no more to read

;READ SECTOR WHICH OVERLAPS PAGE BOUNDARY
NEXT_PAGE:	CALL	SWITCH_MEM			;Switch memory to within page 
							;  boundary
		PUSH	BX				;Save memory address
		ADD	BX,SEC_SIZE[DI]			;Point to spot to read sector to
		MOV	CX,1				;Read one sector
		CALL	READ_WRITE			;Read or write sectors
		POP	BX				;Restore memory address
		PUSHF					;Save error indicator
		CALL	SWITCH_MEM			;Put memory back
		POPF
		JC	RW_DONE				;If read error
	
		INC	DX				;DX = Start sector for next read
		MOV	CX,SEC_TO_READ			
		DEC	CX				;CX = Number of sectors left to read
		JZ	RW_DONE				;If no more to read

		ADD	BX,SEC_SIZE[DI]			;Next sector to read
							; (This will overlap to next page
							;  address)
		CALL	READ_WRITE			;Read the remaining sectors

RW_DONE:	MOV	CX,SECS_XFERD			;Get # of sectors transfered

		LDS	BX,IO_VECTOR			;Get I/O vector
		MOV	CMD_CNT[BX],CX			;Save # sectors transfered

		PUSH	AX				;Save status

		XOR	AH,AH				;Set parameter to timer
		INT	TIMER_INT			;Goto timer

		POP	AX				;Restore status

		MOV	CS:LAST_ACCESS_L,DX
		MOV	CS:LAST_ACCESS_H,CX		;Save timer values

		CLC
		TEST	AH,80h				;Test error bit
		JZ	RDW_EXIT			;No error, goto exit
		STC

RDW_EXIT:	RET
RW_COM		ENDP

		PAGE

;------------------------------------------------------------------------------
;SWITCH_MEM
;
;Description:
;	Switch one sector length of memory from ES:BX with next sector area
;ENTRY:
;	ES:BX = Address to switch
;EXIT:
;	SI destroyed, all other registers preserved
;------------------------------------------------------------------------------

SWITCH_MEM	PROC

		PUSH	AX
		PUSH	BX
		PUSH	CX
		PUSH	DI
		CLD					;Clear direction flag

;POINT TO START ADDRESSES FOR MOVE
		MOV	CX,SEC_SIZE[DI]			;CX = Sector size (# bytes to 
							; transfer)
		MOV	SI,BX				;SI -> Source
		MOV	DI,BX
		ADD	DI,CX				;DI -> Destination
		SHR	CX,1				;CX = # of words to transfer

;SWITCH MEMORY 
SW1:		MOV	AX,ES:[SI]			;AX = Source byte
		MOV	BX,ES:[DI]			;BX = Destination byte
		MOV	ES:[SI],BX			;Store dest at source location
		STOSW					;Store source at dest location
		INC	SI
		INC	SI
		LOOP	SW1				;Switch next set of bytes

		POP	DI
		POP	CX
		POP	BX
		POP	AX
		RET
SWITCH_MEM	ENDP
		PAGE	

;------------------------------------------------------------------------------
;READ_WRITE
;
;Description:
;
;	ENTRY	CX	=	# OF SECTORS TO READ
;		DX	=	STARTING LOGICAL SECTOR
;		ES:BX	=	TRANSFER ADDRESS
;		DS = CS =	Current code segment
;
;		SECS_XFERD  =	Number of sectors transfered
;		CUR_DRV	    = 	Drive unit number
;
;	EXIT	ES:BX	=	Next DMA address
;		C Flag set if error
;		AX	=	Error code
;		CX,DX,DI preserved
;
;		SEC_XFERD updated
;------------------------------------------------------------------------------

READ_WRITE	PROC	

		PUSH	CX
		PUSH	DX
		PUSH	DI

;	Check that the transfer does not exceed the disk capacity

		MOV	SI,DX			;First get starting sector #
		ADD	SI,CX			;Next add the # of sectors to transfer
		CMP	SI,DISK_SIZE[DI]	;Check to see if this transfer is too much
		JBE	CHECK_HD		;Continue if there is enough space

		MOV	AL,REC_NOT_FND		;Indicate error condition
		JMP	ERR_EXIT		;and exit

;	
CHECK_HD:	ADD	DX,HIDDEN_SEC[DI]	;Add # of hidden sectors for this drive
		MOV	COUNT,CX		;Save # sectors count

		MOV	AL,CUR_DRV		;AL = Unit code
		CMP	AL,NUM_LOG_FDDS		;Check to see if this drive is in floppy range
		JB	NUM_FLOP		;Yes, check # of physical FDD

		MOV	AL,ROM_HD0		;Get unit value for HD0
		JZ	COMPUT_PARM		;If HD0, compute DISK INT parameters

		INC	AL			;Get unit code for HD1
		JMP	COMPUT_PARM		;and set up parameters

;
NUM_FLOP:	CMP	NUM_PHY_FDDS,01		;Is there just one physical floppy?
		JNE	COMPUT_PARM		;No, compute parameters to int 13

		CALL	CHECK_FDD		;Yes, check to see if we need to reassign logical to physical

COMPUT_PARM:	MOV	DISK,AL			;Save physical disk #

;	Compute physical sector #

		MOV	AX,DX			;Move starting sector # to AX
		XOR	DX,DX			;DX = 0 for word divide
		DIV	SEC_TRK[DI]		;AX = Track * # of Heads, DX = sector #
		INC	DL			;Convert to physical sector #
		MOV	SECTOR,DL		;Save sector #

;	Compute physical track # & head #

		XOR	DX,DX			;AX = Track * Heads
		DIV	NUM_HEADS[DI]		;AX = Track #, DX = Head #
		
		MOV	TRACK,AX		;Save track
		MOV	HEAD,DL			;and head values

;	Compute # of sectors for this transfer

		MOV	AL,SECTOR		;Get sector #

NUM_SEC:	MOV	CX,COUNT		;Get sectors to transfer
		MOV	DX,SEC_TRK[DI]		;Get sectors per track
		SUB	DL,AL
		INC	DL			;Compute # of sectors remaining on track

		CMP	CX,DX			;Is # sectors to transfer >= # sectors on this track?
		JAE	AOK			;Yes, keep going

		MOV	DL,CL			;No, transfer the remaining sectors

AOK:		MOV	AL,DL			;# of sectors to transfer to AL
		OR	AL,AL			;Check for zero sectors to transfer
		JNZ	RW_CONT			;Sectors to transfer, continue

		JMP	RW_EXIT			;If zero then we are done

RW_CONT:	MOV	SI,NRETRY		;Set retry count

		MOV	AH,COMMAND		;Get command
		AND	AH,NOT VERIFY_MSK	;Strip off verify bit
		MOV	CMD_AND_SEC,AX		;Save command and # of sectors

		PAGE
;	Parameters to INT 13 (disk I/O) AH = command
;					DL = Drive #
;					DH = Head #
;					CH = Track # (low 8 bits)
;					CL = Sector # (bits 6 & 7 are high two bits of 
;							track)
;					AL = # of sectors
;				     ES:BX = Address of DMA buffer

		MOV	DX,TRACK		;Get track value
		MOV	CL,6			;Want to shift bits 8 & 9 to 14 & 15)
		SHL	DH,CL
		OR	DH,SECTOR		;Form new sector parameter
		MOV	CX,DX			;Move track & sector values to CX reg
		XCHG	CH,CL			;Now in correct regs

		MOV	DH,HEAD			;Get head
		MOV	DL,DISK			;and drive values

						;80 TRACK MEDIA SUPPORT
						;RFS:10/15/84

		TEST	DL,80H			;CHECK FOR HARD DISK
		JNZ	AGAIN			;IF HARD DISK SKIP 80 TRK CHK

		MOV	AL,MEDIA[DI]
		TEST	AL,04H			;CHECK FOR 80 TRACK MEDIA
		JNZ	AGAIN
		OR	DL,040H			;SET 80 TRACK FOR BIOS CALL

AGAIN:		MOV	AX,CMD_AND_SEC		;Get command & # sectors

		INT	DSK_INT

		JC	ERROR

		TEST	COMMAND,VERIFY_MSK	;Is verify bit set?
		JZ	ADD_SECTORS		;No, Prepare for next operation

		MOV	AX,CMD_AND_SEC		;RFS 1/22/85
		MOV	AH,VERIFY_CMD		;Yes, verify the transfer
		INT	DSK_INT

		JC	ERROR		

ADD_SECTORS:	MOV	AL,BYTE PTR [CMD_AND_SEC] ;Get # of sectors transfered
		XOR	AH,AH			;Adjust # of sectors transfered
		ADD	SECS_XFERD,AX		;Add sectors just transfered
		SUB	COUNT,AX		;Adjust count of sectors remaining

ADJUST_DMA:	ADD	BX,SEC_SIZE[DI]		;Adjust transfer address for each sector
		DEC	AL			;Do this for each sector transfered	
		JNZ	ADJUST_DMA

		MOV	AL,1			;Start with sector 1
		MOV	SECTOR,AL		;Save starting sector #
		INC	DH			;On next head
		CMP	DH,BYTE PTR NUM_HEADS[DI]	;Is this head # valid
		JNE	ADJ_CONT		;Yes, Go save value

		XOR	DH,DH			;No, select head 0
		INC	TRACK			;and get next track

ADJ_CONT:	MOV	HEAD,DH			;Save head value
		JMP	NUM_SEC			;Compute # sectors for next transfer		
		PAGE

ERROR:		PUSH	AX

		MOV	AH,RECAL_CMD
		INT	DSK_INT

		POP	AX			;Restore Err code & # sectors transfered

		DEC	SI
		JZ	ERR_EXIT

		CMP	AH,TIME_OUT		;Was error a time out?
		JNZ	AGAIN			;No, go retry

ERR_EXIT:	LEA	DI,ERROR_TBL		;Do table lookup on error codes

ERR_LOOP:	CMP	AH,[DI]
		JE	ERR_DONE

		INC	DI			;Point to next entry
		INC	DI
		JMP	ERR_LOOP		;Look for error again
		
ERR_DONE:	MOV	AL,1[DI]		;Get return error code
		MOV	AH,80h			;Set error bit


RW_EXIT:	POP	DI
		POP	DX
		POP	CX
		RET
READ_WRITE	ENDP
		PAGE

CHECK_FDD:
;
;	This routine checks to see if the current drive is the same as the last drive accessed
;	If yes, then the transfer will happen with FDD 0 being selected
;	 else the user is asked to change disks, so the FDD now appears as a different logical drive
;

		MOV	AH,AL			;Get logical drive value to AH
		XCHG	LAST_LOG_FDD,AH		;Save current value and get last value
		CMP	AL,AH			;Is this drive same as the last
		JE	CHECK_END		;Yes, we are done

		ADD	AL,"A"			;Convert unit code to ASCII character for message
		MOV	MESS_DRV,AL		;Save in message
		LEA	SI,MESS			;Point to message

;	Print message to console 

		PUSH	BX
		PUSH	ES			;Save ES

		LEA	DI,MESS			;Set parameters to CON_WRITE

		PUSH	CS
		POP	ES			;ES:DI = address of message

		MOV	CX,MESS_LEN		;# of characters to print in CX
		CALL	CON_WRITE		;Print message

		CALL	CON_IN_FLUSH		;Clear keyboard buffer

		MOV	CX,1
		LEA	DI,MESS_DRV		;ES:DI will contain the user response
		CALL	CON_DEST_READ		;Get one character

		MOV	CX,MESS2_LEN		;# of characters to print
		LEA	DI,MESS2		;Get 2nd message
		CALL	CON_WRITE		;& print it

		POP	ES
		POP	BX

CHECK_END:	XOR	AL,AL			;Use physical floppy 0
		RET

MESS		DB	CR,LF,'Insert diskette for drive '
MESS_DRV	DB	?
		DB	': and press',CR,LF
		DB	'any key when ready. '
MESS_LEN	EQU	$-MESS

MESS2		DB	CR,LF,LF
MESS2_LEN	EQU	$-MESS2

DEND		LABEL	BYTE


		PAGE
;------------------------------------------------------------------------------
;CON_OUT:
;
;Description:
;	INT 29 routine used by DOS for quick console TTY type output 
;
;ENTRY:
;	AL	=	Character to output
;EXIT:
;	NONE
;------------------------------------------------------------------------------

CON_OUT		PROC	FAR
		STI					;Enable interrupts
		PUSH	AX				;Save AX
		MOV	BX,VIDEO_FOR_COLOR		;Set foreground color in graphics mode
		MOV	AH,VIDEO_WRIT_TTY		;Set for write teletype
		INT	VIDEO_INT
		POP	AX
		IRET
CON_OUT		ENDP

;------------------------------------------------------------------------------
;KEY_BREAK
;
;Description:
;	Keyboard Break Interrupt routine
;ENTRY:
;	NONE
;EXIT:
;	BREAK_CHAR (^C) placed in KEYBOARD_BUF
;------------------------------------------------------------------------------

KEY_BREAK	PROC	FAR
		MOV	BYTE PTR CS:[KEYBOARD_BUF],BREAK_CHAR	;Put keyboard break character
		IRET
KEY_BREAK	ENDP

;*************************************************************** 1/24/85  NF
;
;	Patch to timer#1 interrupt:
;	We invoke previous timer#1 interrupt and invoke IBM timer_int.
;	This provides periodic interrupts to any application
;	that wants to use int 8.
;	Warning: this will invoke int 8 at twice IBM rate.
;
Timer1_patch	proc	far

; interrupt call to previous timer1 interrupt handler

		pushf			; trap and interrupt_enable flag
					; assumed cleared at entry.
		db	9ah		; far call
timer1_save_addr	label	word
		dw	0,0		; this code will be modified here!

		int	8		; IBM timer_int
		iret
timer1_patch	endp
;
;*****************************************************************

;------------------------------------------------------------------------------
;INT_RET
;
;Description:
;	Do-nothing interrupt routine -- returns from interrupt
;ENTRY:
;	NONE
;EXIT:
;	NONE
;------------------------------------------------------------------------------

INT_RET		PROC	FAR
		IRET
INT_RET		ENDP

;
;	PATCHED HARD DISK BIOS ROUTINE
;
	INCLUDE	HARD.ASM


		PAGE
;------------------------------------------------------------------------------
;INIT -
;
;Description:
;	The INIT routine is the routine that the boot loader jumps to when it
;	has finished loading IO.SYS.  The INIT routine sets up parameters for 
;	MS DOS, initializes the LPT's and COM's, intializes interrupts, sets up
;	a new disk parameter table for the ROM to use, initializes disk device 
;	driver parameters, loads MSDOS.SYS, and then hands over control to 
;	SYSINIT
;
;ENTRY:
;	AL	=	Boot drive
;	BX	=	Start sector of first file
;	Directory (1st sector) at 50:0
;
;EXIT:	Jump to SYSINIT with CURRENT_DOS_LOCATION, FINAL_DOS_LOCATION, 
;			DEVICE_LIST, MEMORY_SIZE, and DEFAULT_DRIVE initialized
;
;------------------------------------------------------------------------------

INIT:
		PUSH	CS
		POP	DS				;Initialize DS = CS
		MOV	CL,AL				;CL = Boot drive (for INIT_MSDOS)
		MOV	UNIT_CODE,AL			;Save unit code
		MOV	FIRST_FILE_SEC,BX		;Save start sector of first file

;INITIALIZE STACK POINTER
		CLI
		XOR	AX,AX
		MOV	SS,AX
		MOV	SP,STACK_BASE			;Set up stack to 0:STACK_BASE
		STI

;CLEAR ANY INTERRUPTS
		MOV	AL,EOI				;End of interrupt command
		OUT	INTA0,AL			;Send command to controller chip

;SET UP MS-DOS PARAMETERS
		CALL	INIT_MSDOS

;INITIALIZE LPT's 
		MOV	DX,MAX_LPT_NUM			;Maximum supported LPT number

LPT_LOOP:	MOV	AH,LPT_INIT_CMD			
		INT	LPT_INT				;Initialize this LPT
		DEC	DX				;Next LPT number
		JNS	LPT_LOOP			;If all LPT's aren't initalized yet
							; go initialize the next one
		PAGE

;INITIALIZE COM's
		MOV	DX,MAX_COM_NUM			;Maximum supported COM number

COM_LOOP:	MOV	AH,COM_INIT_CMD			;Initialize COM command for ROM
		MOV	AL,COM_VALUES			;Initial COM values:
							; 2400 baud, no parity
							; 1 stop bit, 8 bit character length
		INT	COM_INT				;Initialize this COM
		DEC	DX				;Next COM
		JNS	COM_LOOP			;If all COM's aren't initialized yet,
							; go initialize the next one

;INITIALIZE INTERRUPTS
		CALL	INIT_INT

;INITIALIZE DISK DEVICE DRIVER PARAMETERS
		CALL	INIT_DISK

;LOAD MSDOS.SYS
		CALL	LOAD_MSDOS			

;JUMP TO SYSINIT
		JMP	SYSINIT			

		PAGE
;------------------------------------------------------------------------------
;INIT_MSDOS
;
;Description:
;	Initialize MS DOS parameters
;ENTRY:
;	CL	=	Boot drive
;EXIT:
;	NONE 
;------------------------------------------------------------------------------

INIT_MSDOS	PROC	NEAR
		MOV	AX,SEG	SYSINIT
		MOV	BX,MAX_SYS_LEN			;Number of paragraphs allowed for 
							; SYSINIT code
		ADD	BX,AX				;BX = Load segment for DOS
		MOV	DOS_LOAD_SEG,BX			;Save DOS load segment 

		PUSH	DS				;Save DS

		MOV	DS,AX				;Set data segment to SYSINIT segment
		MOV	WORD PTR CURRENT_DOS_LOCATION,BX	;Set up current DOS segment

		MOV	AX,CS				;Get current code segment
	
		CALL	CHECK_FOR_OLD_ROM		;CHECK ROM VERSION
		JNZ	NOT_OLD_ROM_2			;IF NEW, THEN NO HD BIOS PATCH
		ADD	AX,((OFFSET INIT-OFFSET BEGIN) + 15)/16	;Get AX = segment of INIT code
		JMP	SHORT OLDY
NOT_OLD_ROM_2:						
		ADD	AX,((OFFSET HDROUT-OFFSET BEGIN) + 15)/16 ;Get AX = segment of HDROUT code

OLDY:
		MOV	WORD PTR FINAL_DOS_LOCATION,AX	;Set DOS final segment to INIT code 
							; location
		INC	CL
		MOV	BYTE PTR DEFAULT_DRIVE,CL	;Set up default drive

		MOV	WORD PTR DEVICE_LIST,OFFSET CON_DEV  ;Point to first entry in device 
							     ; list
		MOV	WORD PTR DEVICE_LIST+2,CS

	;CALCULATE MEMORY SIZE
		INT	MEM_SIZE_INT			;Get number of 1K byte blocks
		MOV	CL,6
		SHL	AX,CL				;Get AX=Number of paragraphs
		MOV	WORD PTR MEMORY_SIZE,AX		;Save number of paragraphs

		POP	DS	
		RET
INIT_MSDOS	ENDP		

		PAGE
;------------------------------------------------------------------------------
;INIT_INT
;
;Description:
;	Initialize the Keyboard Break, Int 29, Disk parameter, Single Step, 
;	Breakpoint, Overflow, and Printer interrupt addresses
;		+ HARD DISK BIO PATCH  and timer int patch and int 19.
;ENTRY:
;	NONE
;EXIT:
;	NONE
;------------------------------------------------------------------------------

INIT_INT	PROC
		cli				;****** protect from interrupts
						;****** 1/24/85 NF
		XOR	AX,AX
		MOV	ES,AX				;ES = 0
		CLD					;Clear direction flag for STOSW
							; for SAVE_DOUBLE routine

		MOV	DI,KEY_BRK_ADDR			;Set Keyboard Break Int to KEY_BREAK
		MOV	AX,OFFSET KEY_BREAK
		MOV	BX,CS
		CALL	SAVE_DOUBLE

		MOV	DI,INT29_ADDR			;Set Int 29 to console output routine
		MOV	AX,OFFSET CON_OUT
		CALL	SAVE_DOUBLE

		CALL	CHECK_FOR_OLD_ROM		;CHECK FOR OLD ROM
		JNZ	NOT_OLD_ROM_1			;IF NOT, SKIP BIOS PATCH
		MOV	DI,INT13_ADDR			;SET INT 13 TO NEW
		MOV	AX,OFFSET HDROUT		;HARD DISK ROUTINE
		CALL	SAVE_DOUBLE

;**************************************************** 2/25/85  NF
;
;	ENTRY:	bx=cs, es=0.
;
;	ACTION:	Install patches to interrupts 8, 19, 71.
;
;	EXIT:	bx=cx, es=0

;	Epson timer interrupt (int 71)
;	Move current timer#1 interrupt vector to patch timer address


		push	ds
		push	es

		xor	ax, ax		; ds = absolute 0
		mov	ds, ax

		push	cs
		pop	es		; es = code

		mov	si, timer1_addr
		mov	di, offset timer1_save_addr
		movsw
		movsw

;	Move patch address to timer int vector address
;	Patch sends periodic ints to IBM timer int

		pop	es		; es = absolute 0
		pop	ds		; ds = code

		mov	di, timer1_addr
		mov	ax, offset timer1_patch
		call	save_double		; bx=cs, es=0

;	IBM_timer (int 8)

		mov	ax, offset int_ret
		mov	di, IBM_timer_addr
		call	save_double		; bx=cs, es=0

;	Bootstrap interrupt (int 19)

		mov	di, 19h * 4		; Set to restart vector.
		mov	bx, 0f000h
		mov	ax, 0fff0h
		call	save_double		; es=0

		mov	bx, cs			; restore bx

;****************************************************************

NOT_OLD_ROM_1:

		MOV	DI,DSK_PARM_ADDR		;Set up pointer to new disk parameter table
		MOV	AX,OFFSET DISK_PARAMS
		CALL	SAVE_DOUBLE

		;SET UP ALL DO-NOTHING INTERRUPTS
				
		MOV	DI,SNGL_STEP_ADDR		;Set up SINGLE STEP Interrupt
		MOV	AX,OFFSET INT_RET		;AX ==> IRET routine
		CALL	SAVE_DOUBLE

		MOV	DI,BRKPOINT_ADDR		;Set up BREAKPOINT Interrupt
		CALL	SAVE_DOUBLE

		CALL	SAVE_DOUBLE			;Set up OVERFLOW Interrupt
							; (OVERFLOW follows BREAKPOINT in table)

		MOV	DI,PRNT_ADDR			;Set up PRINTER Interrupt
		CALL	SAVE_DOUBLE			

		sti		;***** 1/24/85 NF 
		RET

INIT_INT	ENDP

		PAGE
;------------------------------------------------------------------------------
;SAVE_DOUBLE
;
;Description:
;	Save double word in memory
;ENTRY:
;	BX = High word
;	AX = Low word
;	ES:DI	=	Destination address
;EXIT:
;	ES:DI	->	Next address
;	All other registers unchanged	
;------------------------------------------------------------------------------

SAVE_DOUBLE	PROC
		STOSW					;Store offset
		XCHG	BX,AX
		STOSW					;Store segment
		XCHG	BX,AX				;Restore BX,AX
		RET
SAVE_DOUBLE	ENDP

		PAGE
;------------------------------------------------------------------------------
;INIT_DISK
;
;Description:
;	Initialize disk device parameters -- NUM_PHYS_FDDS, NUM_LOG_FDDS, and 
;	Hard disk BPB's, if necessary.
;ENTRY:
;	NONE
;EXIT:
;	NONE
;------------------------------------------------------------------------------

INIT_DISK	PROC

	;SET NUMBER OF LOGICAL AND PHYSICAL FLOPPIES
		INT	EQUIP_INT			;Equipment flag
		AND	AL,DRV_MASK			;Get drive bits
		ROL	AL,1
		ROL	AL,1				;Get drive bits in low 2 bits
		INC	AL				;Get number of drives
		MOV	NUM_PHY_FDDS,AL			;Set number of physical drives
		CMP	AL,1
		JNZ	A1				;If more than one physical floppy

		INC	AL				;If only one physical, set to two logical

A1:		MOV	NUM_LOG_FDDS,AL			;Set number of logical floppies

	;INITIALIZE NUMBER OF DRIVES TO NUMBER OF FLOPPIES
		MOV	BYTE PTR [MAXDRV],AL		;Set value in device header

	;BUILD HARD DISK BPB'S
		MOV	AH,HD_PARAM_CMD			;Get hard disk parameters
		MOV	DL,HD_DRV_0			;Indicate hard disk drive 0
		INT	DSK_INT	
		JC	D_EXIT				;If error in getting hard disk parameters
							; (Error occurs if there is no hard disk 
							; device driver) 
		OR	DL,DL
		JZ	D_EXIT				;Done if no hard disks

A2:		MOV	NUM_HARD_DISKS,DL		;Save number of hard disks
		MOV	BX,OFFSET DSKDPB+4		;BX points to first hard disk BPB address
		MOV	DL,HD_DRV_0			;DL = First drive to build BPB for

A3:		CALL	BUILD_BPB			;Build hard disk BPB
		JC	A4				;If error, don't add to total drive count

		INC	BYTE PTR [MAXDRV]		;Increment total number of drives
		ADD	BX,2				;Point to next BPB address
		
A4:		INC	DL				;Next hard disk
		DEC	NUM_HARD_DISKS			;Get number of hard disks left 
		JNZ	A3				;Build next BPB
D_EXIT:		RET

INIT_DISK	ENDP

		PAGE
;------------------------------------------------------------------------------
;BUILD_BPB:
;
;Description:
;	Build hard disk BPB
;ENTRY:
;	DL	=	Drive code for ROM (80 = HD drive 0, etc)
;	BX	=	Pointer to BPB address
;EXIT:
;	C Flag set if error
;	DX,BX unchanged
;------------------------------------------------------------------------------

BUILD_BPB	PROC	

		PUSH	BX			;Save pointer to BPB address
		PUSH	DX			;Save drive code
		MOV	DI,[BX]			;DI => BPB

;CALL ROM TO GET NUMBER OF HEADS AND SECTORS PER TRACK
		MOV	AH,HD_PARAM_CMD
		INT	DSK_INT			;Get parameters for this drive
		JC	BEXIT			;Error exit
		
		INC	DH			;DH = number of heads
		MOV	DL,DH
		XOR	DH,DH			;DX = Number of heads
		MOV	[DI+NUM_HEADS],DX	;Save in BPB
		AND	CX,SEC_MASK		;Get number of sectors/track
		MOV	[DI+SEC_TRK],CX		;Save in BPB
		
;GET OTHER INFORMATION FROM BOOT SECTOR
		XOR	BX,BX
		MOV	ES,BX
		MOV	BX,BUFFER		;ES:BX = Buffer address
		POP	DX			;Get drive code
		PUSH	DX	
		CALL	READ_BOOT		;Read boot sector and make sure it's valid
		JC	BEXIT			;Error exit

	;SEARCH BOOT SECTOR FOR INFORMATION
		MOV	BX,BUFFER+SEARCH_START		;BX = Start address for search
NEXT_SEARCH:	CMP	BYTE PTR ES:[BX],INFO_FLAG	;Search for INFO_FLAG
		JZ	INFO_FOUND			;If INFO found

		ADD	BX,INFO_LENGTH		;Point to next place to check
		CMP	BX,BUFFER+HD_SEC_SIZE
		JB	NEXT_SEARCH		;If not at end of sector, check next spot

		STC				;Indicate error
		JMP	SHORT BEXIT		;Error exit

INFO_FOUND:	CALL	SET_INFO		;Set up remaining information
						;C Flag set if error
BEXIT:		POP	BX
		POP	DX
		RET
BUILD_BPB	ENDP		
				
		PAGE
;------------------------------------------------------------------------------
;READ_BOOT
;
;Description:
;	Read in boot sector and check last two bytes for valid boot sector code
;ENTRY:
;	DL	=	Drive code
;	ES:BX	=	Buffer address
;EXIT:
;	C Flag set if error
;------------------------------------------------------------------------------

READ_BOOT	PROC

		MOV	CX,BOOT_TRK_SEC			;CH = Boot track, CL = Boot sector
		MOV	AH,READ_CMD			;AH = Read command
		MOV	AL,BOOT_LEN			;AL = Number of sectors to read
		XOR	DH,DH				;DH = Head 0
		INT	DSK_INT				;Read boot sector
		JC	REXIT				;Error return

		MOV	AX,WORD PTR ES:[BX+CODE_LOC]
		CMP	AX,CODE_VAL
		JZ	REXIT				;If valid boot code, return good

		STC					;If invalid, return error

REXIT:		RET

READ_BOOT	ENDP



		PAGE
;------------------------------------------------------------------------------
;SET_INFO
;
;Description:
;	Set up all BPB values except number of heads and sectors/track
;ENTRY:
;	ES:BX	=>	Boot sector information table
;	DI	=>	BPB
;
;EXIT:
;	C Flag set if error
;------------------------------------------------------------------------------

SET_INFO	PROC
		
;SET NUMBER OF HIDDEN SECTORS
		MOV	AX,ES:[BX+OFF_HIDDEN]		;Get number of hidden sectors
							; from boot sector
		MOV	[DI+HIDDEN_SEC],AX		;Save in BPB

;GET NUMBER OF SECTORS/CLUSTER AND NUMBER OF DIRECTORY ENTRIES
		MOV	AX,ES:[BX+OFF_SEC]		;AX = Number of sectors
		MOV	[DI+DISK_SIZE],AX		;Save in BPB	
		CMP	AX,LEAST_SECTORS		;Check if a valid number of sectors
		JC	S_EXIT				;Error exit if not enough sectors

		MOV	CL,1				;CL = Number of sectors/cluster (1)
		MOV	DX,40H				;DX = Number of directory entries (40h)
		CMP	AX,200H			
		JBE	S1				;If <= 200h sectors, use these values
		
		SHL	CL,1				;Double number of sectors/cluster (2)
		MOV	DX,70H				;Update number of directory entries (70h)
		CMP	AX,800H			
		JBE	S1				;If <= 800h sectors, use these values

		SHL	CL,1				;Double number of sectors/cluster (4)
		MOV	DX,100H				;Update number of directory entries (100h)
		CMP	AX,2000H
		JBE	S1				;If <= 2000h sectors, use these values

		SHL	CL,1				;Double number of sectors/cluster (8)
		SHL	DX,1				;Double number of directroy entries (200h)
		CMP	AX,7FABH			
		JBE	S1				;If <= 7FABh sectors, use these values

		SHL	CL,1				;Double number of sectors/cluster (16)
		SHL	DX,1				;Double number of directory entries (400h)

;SAVE NUMBER OF SECTORS/CLUSTER AND NUMBER OF DIRECTORY ENTRIES
S1:		MOV	[DI+NUM_DIR],DX			;Save number of directory entries in BPB
		MOV	[DI+ALLOC_SIZE],CL		;Save number of sectors/cluster

		PAGE
;CALCULATE NUMBER OF SECTORS/FAT
		
	;GET NUMBER OF CLUSTERS
		XOR	CH,CH				;Get CX = Number of sectors/cluster	
		ADD	AX,CX				
		DEC	AX				;AX = # SECTORS + (# SECTORS/CLUSTER - 1)
							; (FOR ROUNDING UP ON DIVIDE)
		XOR	DX,DX				;Clear DX for divide
		DIV	CX				;AX = # CLUSTERS

	;GET NUMBER OF BYTES/FAT
							;EACH FAT ENTRY IS 1.5 BYTES/CLUSTER
							;MULTIPLY (TOTAL # CLUSTERS) * 
							; (1.5 BYTES/CLUSTER) TO GET # BYTES/FAT

 
		MOV	SI,AX				;SI = # clusters
		INC	AX				;Round up # clusters for divide by 2
		SHR	AX,1				;AX = .5 * # clusters
		ADD	AX,SI				;AX = 1.5 * # clusters = # bytes/FAT

	;GET NUMBER OF SECTORS/FAT
		XOR	DX,DX				;Clear DX for divide
		MOV	BX,HD_SEC_SIZE			;BX = Number of bytes/sector
		ADD	AX,BX
		DEC	AX				;Round up # of bytes in FAT
		DIV	BX				;AX = Number of sectors/FAT
		MOV	[DI+SEC_FAT],AX			;Save number of sectors/FAT in BPB

;SET UP REMAINING BPB VALUES
		MOV	[DI+SEC_SIZE],HD_SEC_SIZE	;Save sector length
		MOV	[DI+RES_SEC],HD_RES_SEC		;Save number of reserved sectors
		MOV	[DI+NUM_FAT],HD_NUM_FAT		;Save number of FAT's
		MOV	[DI+MEDIA],HD_MEDIA		;Save media byte 

		CLC					;Indicate no error

S_EXIT:		RET

SET_INFO	ENDP

		PAGE
;------------------------------------------------------------------------------
;LOAD_MSDOS
;
;Description:
;	Load MSDOS.SYS to CURRENT_DOS_LOCATION.  This is done by getting the 
;	start cluster from the directory stored by the boot routine, loading the 
;	FAT into BUFFER, and looking up the number of consecutive clusters in 
;	the FAT.  Then LOAD_MSDOS calls the disk device driver's DREAD routine
;	to read the consecutive clusters.  The process of reading in consecutive
;	clusters is continued until the entire file is loaded.	
;
;ENTRY:
;	NONE
;EXIT:	
;	C Flag set if error
;------------------------------------------------------------------------------

LOAD_MSDOS	PROC	

;READ FAT INTO BUFFER
		XOR	AX,AX
		MOV	ES,AX				;ES = 0
		MOV	DI,BUFFER			;ES:DI = DMA Address
		MOV	TRAN_ADDR,DI			
		MOV	TRAN_SEG,AX			;TRAN_SEG:TRAN_ADDR = DMA address
		CALL	READ_FAT
		JC	R_EXIT				;Error exit

;GET CORRECT MEDIA BYTE FROM FAT
		MOV	AL,ES:[DI]			;Media byte = first byte of FAT
		MOV	MEDIA_BYTE,AL

;GET BPB
		MOV	COMMAND_CODE,BPB_CODE		;Request BPB
		CALL	DISK_DRIVER
		MOV	BX,[BPB_PTR]			;BX -> BPB

;CALCULATE START SECTOR OF DISK'S DATA AREA
		MOV	AX,FIRST_FILE_SEC		;Get start sector of first file
		SUB	AX,[BX+HIDDEN_SEC]		;Subtract # of hidden sectors
							; to get AX= Logical start sector
							; for data area
		MOV	DATA_START,AX			;Save logical start sector for 
							; data area

;GET NUMBER OF SECTORS/CLUSTER AND STARTING CLUSTER NUMBER
		XOR	CH,CH
		MOV	CL,[BX+ALLOC_SIZE]		;CX = Number of sectors/cluster
		MOV	BX,ES:[DIRECTORY+FILE_2_CLUST]	;BX = Start cluster for file 2
							;  (ES:DIRECTORY= Boot Directory)
;INITIALIZE DMA ADDRESS
		XOR	DX,DX				;DX = DMA offset address
		MOV	TRAN_ADDR,DX			
		MOV	AX,DOS_LOAD_SEG
		MOV	TRAN_SEG,AX			;TRAN_SEG:TRAN_ADDR = DMA Address 

;INITIALIZE READ COMMAND IN REQUEST HEADER
		MOV	COMMAND_CODE,READ_CODE		;Prepare to read
		PAGE
;GET STARTING LOGICAL SECTOR
		
R_LOOP:		MOV	AX,BX				;Get start cluster number
		DEC	AX
		DEC	AX				;First cluster is cluster 2
		MUL	CX				;Get starting sector # within
							; data area for this cluster
		ADD	AX,DATA_START			;AX = Logical start sector for
							; this cluster
		MOV	START_SEC,AX			;Save start sector in request 
							; header
;GET NUMBER OF CONTIGUOUS SECTORS TO READ
		MOV	READ_LEN,CX			;Initialize # of sectors to read
							; to # of sectors in a cluster
R1:		CALL	GET_FAT_ENTRY			;Get FAT entry for this sector
							; SI = Last cluster number, 
							; BX = Next sector number
		SUB	SI,BX				;Calculate distance from current 
							; sector to next sector
		CMP	SI,-1				;Check if sectors are contiguous
		JNZ	R2				;If no more contiguous sectors, 
							; go read the contiguous sectors
							; found so far
		ADD	READ_LEN,CX			;If contiguous, add to number of 
							; sectors to read
		JMP	SHORT R1			;Go check next sector 

;READ SECTORS
R2:		
		CALL	DISK_DRIVER			;Read the sectors
		MOV	AX,STATUS_WORD			;Check for error
		SHL	AX,1				;Move error bit to C Flag
		JC	R_EXIT				;Exit if error

;CALCULATE NEXT DMA ADDRESS
		MOV	AX,READ_LEN			;Get number of sectors read
		XCHG	AL,AH				;Get # sectors * 256
		SHL	AX,1				;Get # sectors * 512 = # of bytes
		ADD	AX,DX
		MOV	TRAN_ADDR,AX			;Set next DMA address

		CMP	BX,EOF_MARKER			;Check for end of file
		JNZ	R_LOOP				;Read next set of contiguous 
							; sectors 
		CLC					;Indicate no error
R_EXIT:		RET

LOAD_MSDOS	ENDP



		PAGE
;------------------------------------------------------------------------------
;READ_FAT
;
;Description:
;	Read FAT into specified buffer
;ENTRY:
;	TRAN_SEG:TRAN_ADDR 	=	Buffer address
;EXIT:
;	C Flag set if error
;	AX destroyed
;------------------------------------------------------------------------------

READ_FAT	PROC
		MOV	AX,1				
		MOV	READ_LEN,AX			;Only need first FAT sector
		MOV	START_SEC,AX			;Start with logical sector 1
		MOV	COMMAND_CODE,READ_CODE		;Perform read operation
		CALL	DISK_DRIVER			;Read the sector
		MOV	AX,STATUS_WORD			;Check for error
		SHL	AX,1				;Get error bit in C Flag
		RET
READ_FAT	ENDP



		PAGE
;------------------------------------------------------------------------------
;DISK_DRIVER
;
;Description:
;	Calls disk device driver
;ENTRY:
;	REQ_HDR set up for call
;	DS	=	CS
;EXIT:
;	All registers preserved
;	REQ_HDR set up as defined for disk device driver
;------------------------------------------------------------------------------

DISK_DRIVER	PROC

		MOV	VECTOR_OFF,OFFSET REQ_HDR		;Set REQ_HDR address
		MOV	VECTOR_SEG,CS				;  for DISK_INT
		CALL	FAR PTR DISK_INT			;Call disk device driver
		RET

DISK_DRIVER	ENDP
		PAGE

;------------------------------------------------------------------------------
;GET_FAT_ENTRY
;
;Description:
;	Look up next sector in FAT table
;ENTRY:
;	BX	=	Cluster number to look up	
;	FAT stored in 0:BUFFER
;EXIT:
;	SI	=	Cluster number looked up
;	BX	=	Next cluster number
;------------------------------------------------------------------------------

GET_FAT_ENTRY	PROC
		PUSH	DS				;Save data segment
		MOV	AX,BUFFER/16			
		MOV	DS,AX				;Set segment register to point to 
							; BUFFER so offset can be 0
		MOV	SI,BX				;Get SI = Cluster number to look up
		SHR	BX,1				;BX = Cluster number * .5
		MOV	BX,[SI+BX]			;BX = FAT word for this cluster
		JNC	G1				;If even cluster number

		SHR	BX,1				;If odd cluster number, shift cluster
		SHR	BX,1				; bits down to low order bits of BX
		SHR	BX,1
		SHR	BX,1

G1:		AND	BX,0FFFH			;Get FAT bits
		POP	DS				;Restore data segment
		RET

GET_FAT_ENTRY	ENDP


;01/12/85
;
;CHECK FOR OLD ROM, THAT HAS DEFECTIVE HARD DISK BIOS ROUTINE
;
;	IDENTIFY AS HAVING: FFH IN LOCATION F000:FFFEH
;
;	ON EXIT: NZ IF NEW ROM	( WITH PATCHED BIOS ROUTINE)
;		 ZERO FLAG SET IF OLD ROM
;
CHECK_FOR_OLD_ROM PROC	NEAR
		PUSH	AX		;SAVE AX
		PUSH	DS		;SAVE DS
		MOV	AX,0F000H	
		MOV	DS,AX
		MOV	AL,BYTE PTR DS:0FFFEH	;GET BYTE AT 0F000:FFFE (ID BYTE)
		INC	AL		;SET CARRY FLAG IF AL=0FFH
		POP 	DS		;RESTORE DS
		POP	AX		;RESTORE AX
		RET
CHECK_FOR_OLD_ROM	ENDP


		PAGE
;******************************************************************************
;				VARIABLES
;******************************************************************************

;*NOTE*
;	All varibles defined here are used by INIT code only
;	This space will be overwritten by the DOS

NUM_HARD_DISKS	DB	0				;Temporarily holds number of 
							;  hard disks
DOS_LOAD_SEG	DW	0				;Holds DOS load address
FIRST_FILE_SEC	DW	0				;Holds start sector of first file
DATA_START	DW	0				;Holds logical start sector of 
							;  data area

REQ_HDR		DB	REQ_LEN				;Length of request header
UNIT_CODE	DB	0				;Device unit code 
COMMAND_CODE	DB	0				;Command code number
STATUS_WORD	DW	0				;Error status
		DB	0,0,0,0,0,0,0,0			;Name field
MEDIA_BYTE	DB	0FEH				;Media byte for request
TRAN_ADDR	DW	0				;Transfer buffer address
TRAN_SEG	DW	0				;Transfer buffer segment
READ_LEN	LABEL	WORD				;Number of sectors to read
BPB_PTR		DW	0				;Pointer to BPB (Same location in 
							;  request header as READ_LEN)
START_SEC	DW	0				;Starting logical sector number


CSEG		ENDS
		END	BEGIN

